/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_config.c 249 2009-04-30 07:02:21Z ertl-honda $
 */

/*
 *        ¸⥸塼ARMѡ
 */
#include "kernel_impl.h"
#include "check.h"
#include "task.h"

/*
 *  start.S ǤƱѿ
 */
volatile uint_t start_sync;

#ifndef VECTOR_KERNEL
/*
 * 㳰٥˽񤭹ޤ줿̿᤬Ȥ륢ɥ쥹
 */
uint32_t *arm_vector_ref_tbl_add[8];

/*
 * 㳰˱ϥɥεư
 */
uint32_t arm_saved_exch_add[8];
#endif

/*
 *  ץå¸ν
 */
void
core_initialize(void)
{
	/*
	 *  ͥ뵯ư󥿥ƥȤȤư뤿1
	 */ 
	my_p_accb->excpt_nest_count = 1;
    
#ifndef VECTOR_KERNEL
	{
		uint32_t i, vector_value;

		/*
		 * 㳰٥ϿƤ̿ᤫ黲Ȥ륢ɥ쥹ȡ
		 * Υɥ쥹(ϥɥ)¸롥
		 */
		for(i = 0; i < TNUM_EXCH; i++){
			vector_value = *(volatile uint32_t *)(VECTOR_START + (i*4));
			vector_value &= 0x00000fff;
			arm_vector_ref_tbl_add[i]  =  (uint32_t *)(vector_value + 8) + i;
			arm_saved_exch_add[i] = *(arm_vector_ref_tbl_add[i]);
		}
	}
#endif /* VECTOR_KERNEL */
}

/*
 *  ץå¸νλ
 */
void
core_terminate(void)
{
	extern void    software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *  Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}

#ifndef VECTOR_KERNEL
	uint32_t i;

	/*
	 * 㳰٥򸵤᤹
	 */
	for(i = 0; i < TNUM_EXCH; i++){
		*arm_vector_ref_tbl_add[i]  = arm_saved_exch_add[i];
	}
#endif /* VECTOR_KERNEL */

	start_sync = 0;
}

/*
 *  CPU㳰ȯΥ
 *
 *  CPU㳰ϥɥ椫顤CPU㳰ݥ󥿡p_excinfˤȤ
 *  ƸƤӽФȤǡCPU㳰ȯ򥷥ƥ˽Ϥ롥
 */
#ifdef SUPPORT_XLOG_SYS

void
xlog_sys(void *p_excinf)
{
}

#endif /* SUPPORT_XLOG_SYS */

/*
 *  㳰٥ľܼ¹ԤϥɥϿ
 */ 
void
x_install_exc(EXCNO excno, FP exchdr)
{
#ifdef VECTOR_KERNEL
	*(((FP*)vector_ref_tbl) + excno) = exchdr;
#else
	*arm_vector_ref_tbl_add[excno] = (uint32_t)exchdr;
#endif /* VECTOR_KERNEL */
}

#ifndef OMIT_DEFAULT_EXC_HANDLER
/*
 * ̤㳰äν
 */
void
default_exc_handler(void){
	ID prc_id = ID_PRC(x_prc_index());

	syslog_1(LOG_EMERG, "Processor %d : Unregistered Exception occurs.", prc_id);
	target_exit();
}
#endif /* OMIT_DEFAULT_EXC_HANDLER */
