/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_config.h 266 2009-05-14 06:32:27Z ertl-honda $
 */

/*
 *  åװ¸⥸塼MPCOREѡ
 *
 *  ͥΥåװ¸Υ󥯥롼ɥե롥kernel_impl.hΥ
 *  åȰ¸ΰդȤʤ롥
 */

#ifndef TOPPERS_CHIP_CONFIG_H
#define TOPPERS_CHIP_CONFIG_H

/*
 *  åװ¸ΤΥϡɥ񸻤
 */
#include "mpcore.h"

/*
 *  ٥롼򥫡ͥǻĤ
 */
#define VECTOR_KERNEL

/*
 *  ֹΥޥʲ16bitΤߤͭ
 */
#define INTNO_MASK(intno) (intno & 0xffffU)

/*
 *  ߥϥɥֹΥޥʲ16bitΤߤͭ
 */
#define INHNO_MASK(intno) (intno & 0xffffU)

/*
 *  ߥϥɥֹȳֹ˴ؤ
 */
#define TMIN_INTNO  DIC_TMIN_INTNO
#define TMAX_INTNO  DIC_TMAX_INTNO
#define TNUM_INT    DIC_TNUM_INT

#define TMIN_INHNO  DIC_TMIN_INTNO
#define TMAX_INHNO  DIC_TMAX_INTNO
#define TNUM_INH    DIC_TNUM_INT

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ޥץå֤
 */
Inline bool_t
x_sense_mprc(void){
	if(x_prc_index() == (TOPPERS_MASTER_PRCID - 1)) {
		return true;
	}
	else {
		return false;
	}
}

/*
 *  åط
 */
/*
 *  åη
 */
#define TSKLOCK   uint_t
#define OBJLOCK   uint_t
#define POBJLOCK  uint_t*
#define GLOCK     uint_t

/*
 *  åμ
 */
Inline bool_t
acquire_lock(uint32_t *p_lock)
{
	int locked;

	Asm("   mov      r2, #0x01   \n"
		"\t ldrex    r1, [%1]    \n"
		"\t cmp      r1, #0x00   \n"
		"\t wfene                \n"
		"\t strexeq  r1, r2,[%1] \n"
		"\t mov      %0, r1      \n"
		:"=r"(locked):"r"(p_lock):"r1","r2", "cc");

	if(locked == 0){
		/* false꥿ */
		mpcore_data_memory_barrier();
		Asm("":::"memory");
		return(false);
	}

	return (true);
}

/*
 *  åμ
 */
Inline bool_t
try_acquire_lock(uint32_t *p_lock)
{
	int locked;

	Asm("   mov      r2, #0x01   \n"
		"\t ldrex    r1, [%1]    \n"
		"\t cmp      r1, #0x00   \n"
		"\t strexeq  r1, r2,[%1] \n"
		"\t mov      %0, r1      \n"
		:"=r"(locked):"r"(p_lock):"r1","r2", "cc");

	if (locked == 0) {
		/* ꥿ */
		mpcore_data_memory_barrier();
		Asm("":::"memory");
		return(false);
	}

	return(true);
}

/*
 *  åβ
 */
Inline void
release_lock(uint32_t *p_lock)
{
	Asm("":::"memory");
	mpcore_data_memory_barrier();
	*p_lock = 0;
	mpcore_data_sync_barrier();
	Asm("sev");
}

/*
 *  㥤ȥåνG_LOCKξ
 */
Inline void
x_initialize_giant_lock(GLOCK *p_giant_lock)
{
	*p_giant_lock = 0;
}

/*
 *  㥤ȥåμ
 */
Inline bool_t
x_acquire_giant_lock(GLOCK *p_giant_lock)
{
	return acquire_lock(p_giant_lock);
}

#define t_acquire_giant_lock(p_giant_lock) x_acquire_giant_lock(p_giant_lock)
#define i_acquire_giant_lock(p_giant_lock) x_acquire_giant_lock(p_giant_lock)

/*
 *  㥤ȥåβ
 */
Inline void
x_release_giant_lock(GLOCK *p_giant_lock)
{
	release_lock(p_giant_lock);
}

#define t_release_giant_lock(p_giant_lock) x_release_giant_lock(p_giant_lock)
#define i_release_giant_lock(p_giant_lock) x_release_giant_lock(p_giant_lock)

/*
 *  åν
 */
Inline void
x_initialize_tsk_lock(TSKLOCK *p_tsk_lock)
{
	*p_tsk_lock = 0;
}

/*
 *  åμ
 */
Inline bool_t
x_acquire_tsk_lock(TSKLOCK *p_tsk_lock)
{
	return acquire_lock(p_tsk_lock);
}

#define t_acquire_tsk_lock(p_tsk_lock)  x_acquire_tsk_lock(p_tsk_lock)
#define i_acquire_tsk_lock(p_tsk_lock)  x_acquire_tsk_lock(p_tsk_lock)

/*
 *  åβ
 */
Inline void
x_release_tsk_lock(TSKLOCK *p_tsk_lock)
{
	release_lock(p_tsk_lock);
}

#define t_release_tsk_lock(p_tsk_lock) x_release_tsk_lock(p_tsk_lock)
#define i_release_tsk_lock(p_tsk_lock) x_release_tsk_lock(p_tsk_lock)

/*
 *  ֥ȥåν
 */
Inline void
x_initialize_obj_lock(OBJLOCK *p_obj_lock)
{
	*p_obj_lock = 0;
}

/*
 *  ֥ȥåμ
 */
Inline bool_t
x_acquire_obj_lock(OBJLOCK *p_obj_lock)
{
	return acquire_lock(p_obj_lock);
}

#define t_acquire_obj_lock(p_obj_lock) x_acquire_obj_lock(p_obj_lock)
#define i_acquire_obj_lock(p_obj_lock) x_acquire_obj_lock(p_obj_lock)

/*
 *  ֥ȥåβ
 */
Inline void
x_release_obj_lock(OBJLOCK *p_obj_lock)
{
	release_lock(p_obj_lock);
}

#define t_release_obj_lock(p_obj_lock) x_release_obj_lock(p_obj_lock)
#define i_release_obj_lock(p_obj_lock) x_release_obj_lock(p_obj_lock)

/*
 *  ԥåǽΥͥƥ֥åǻѤؿ
 */

/*
 *  ԥåη
 */
#define SPNLOCK   uint32_t

/*
 *  ԥåν
 */
Inline void
x_initialize_spin(ID spnid, SPNLOCK *p_spn_lock)
{
	*p_spn_lock = 0;
}

/*
 *  ԥåμ
 */
Inline bool_t
x_lock_spin(SPNLOCK *p_spn_lock)
{
	return acquire_lock(p_spn_lock);
}

#define t_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)
#define i_lock_spin(p_spn_lock)  x_lock_spin(p_spn_lock)

/*
 *  ԥåμλ
 */
Inline bool_t
x_try_lock_spin(SPNLOCK *p_spn_lock)
{
	return try_acquire_lock(p_spn_lock);
}

#define t_try_lock_spin(p_spn_lock) x_try_lock_spin(p_spn_lock)
#define i_try_lock_spin(p_spn_lock) x_try_lock_spin(p_spn_lock)

/*
 *  ԥåβ
 */
Inline void
x_unlock_spin(SPNLOCK *p_spn_lock)
{
	release_lock(p_spn_lock);
}

#define t_unlock_spin(p_spn_lock) x_unlock_spin(p_spn_lock)
#define i_unlock_spin(p_spn_lock) x_unlock_spin(p_spn_lock)

/*
 *  ֹϰϤȽ
 */
#define VALID_INTNO(intno) ((TMIN_INTNO <= INTNO_MASK(intno)) && (INTNO_MASK(intno) <= TMAX_INTNO))
#define VALID_INTNO_DISINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_CFGINT(intno)    VALID_INTNO(intno)
#define VALID_INTNO_ATTISR(intno)    VALID_INTNO(intno)

/*
 *  ߥϥɥ
 * 
 *  ߥϥɥֹinhnoγߥϥɥεưϤinthdrꤹ
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry, uint_t affinity_mask)
{
	assert(((TMIN_INHNO <= INHNO_MASK(inhno)) && (INHNO_MASK(inhno) <= TMAX_INHNO)));
}

/*
 *  ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)    inthdr
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)

#endif /* TOPPERS_MACRO_ONLY */  

/*
 *  ͥ٥ޥ饤֥
 *
 *  DICǤϡDICͥ٥쥸CPUγͥ٥ޥIPMˤꤹ롥
 *  ͥ٥ޥ0x0  0xf 16ʳͤ礭ۤͥ٤Ǥ롥
 *  IPM¸Ƥˡͥ٤γɽ-1Ϣ³͡
 *  ȤȤǽǤ뤬;פʷ׻ɬפˤʤ롥򤱤뤿ᡤIPM
 *  ¸ˤϡDICǰͥ٤ηȤ롥ͤͥ٥ޥ
 *  ɽȸƤӡIIPMȽ񤯤Ȥˤ롥 
 */

/*
 *  ͥ٥ޥγɽɽѴ
 *
 *  ֥Υե뤫饤󥯥롼ɤΤˡ
 *  㥹ȤʤѰդƤ롥
 */
#ifndef TOPPERS_MACRO_ONLY
#define EXT_IPM(iipm)    ((PRI)(iipm - 0x0fU))    /* ɽɽ */
#define INT_IPM(ipm)    ((uint8_t)(ipm + 0x0fU))/* ɽɽ */
#else /* TOPPERS_MACRO_ONLY */
#define EXT_IPM(iipm)    (iipm - 0xf)            /* ɽɽ */
#define INT_IPM(ipm)    (ipm + 0xf)                /* ɽɽ */
#endif /* TOPPERS_MACRO_ONLY */

/*
 *  TIPM_ENAALLʳͥ٥ޥˤɽ
 */
#define IIPM_ENAALL        (INT_IPM(TIPM_ENAALL))

#ifndef TOPPERS_MACRO_ONLY

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint8_t
current_iipm(void)
{
	return(dic_cpu_current_priority());
}

/*
 *  IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint8_t iipm)
{
	dic_cpu_set_priority(iipm);
}

/*
 * (ǥ)ͥ٥ޥ
 */
Inline void
x_set_ipm(PRI intpri)
{
	set_iipm(INT_IPM(intpri));
}

#define t_set_ipm(intpri) x_set_ipm(intpri)
#define i_set_ipm(intpri) x_set_ipm(intpri)

/*
 *  (ǥ)ͥ٥ޥλ
 */
Inline PRI
x_get_ipm(void)
{
	return(EXT_IPM(current_iipm()));
}

#define t_get_ipm() x_get_ipm()
#define i_get_ipm() x_get_ipm()

/*
 *  °ơ֥
 *  
 *  °ơ֥ؤΥݥ󥿡°ơ֥ϡ°
 *  Ƥ"1"ꤵƤʤ"0"Ȥʤ
 */
extern const uint8_t* const p_cfgint_table[];

#define my_cfgint_table (p_cfgint_table[x_prc_index()])

/*
 * ʥǥΡ˳׵ػߥե饰Υå
 *
 *  ꤵ줿ֹγ׵ػߥե饰ΥåȤơߤ
 *  ػߤ롥
 *    
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤  
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	if (my_cfgint_table[INTNO_MASK(intno)] == 0){
		return(false);
	}
    
	dic_disable_int(INTNO_MASK(intno));
	return(true);
}

#define t_disable_int(intno)  x_disable_int(intno)
#define i_disable_int(intno)  t_disable_int(intno)

/* 
 *  (ǥ)׵ػߥե饰β
 *
 *  ꤵ줿ֹγ׵ػߥե饰Υꥢơߤ
 *  Ĥ롥
 *
 *  °ꤵƤʤ׵饤ФƳ׵ػ
 *  ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	if (my_cfgint_table[INTNO_MASK(intno)] == 0){
		return(false);
	}
    
	dic_enable_int(INTNO_MASK(intno));
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 * ׵Υꥢ
 */
Inline void
x_clear_int(INTNO intno)
{
	dic_clear_pending(INTNO_MASK(intno));
}

#define t_clear_int(intno) x_clear_int(intno) 
#define i_clear_int(intno) x_clear_int(intno) 

/*
 *  ׵Υå
 */
Inline bool_t
x_probe_int(INTNO intno)
{
	return(dic_probe_int(INTNO_MASK(intno)));
}

#define t_probe_int(intno) x_probe_int(intno)
#define i_probe_int(intno) x_probe_int(intno)

/*
 *  ׵饤°
 *
 */
extern void x_config_int(INTNO intno, ATR intatr, PRI intpri, uint_t affinity_mask);

/*
 * ߥϥɥɬפIRC
 *
 */
Inline void
i_begin_int(INTNO intno)
{    
}

/*
 * ߥϥɥνиɬפIRC
 */
Inline void
i_end_int(INTNO intno)
{
}

/*
 *  str_ker() ǥޥץåǹԤ
 */
extern void chip_mprc_initialize(void);

/*
 *  åװ¸ν
 */
extern void chip_initialize(void);

/*
 *  åװ¸νλ
 *
 *  ƥλ˻Ȥ
 */
extern void chip_exit(void);

/*
 *  ߥϥɥchip_support.S
 */
extern void interrupt_handler(void);

/*
 *  ̤γߤäν
 */
extern void default_int_handler(void);


#endif /* TOPPERS_MACRO_ONLY */

/*
 *  ARM¸⥸塼
 */
#include "arm_gcc/common/core_config.h"

#endif /* TOPPERS_CHIP_CONFIG_H */
