/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: mp.h 333 2009-07-17 04:13:48Z ertl-honda $
 */

/*
 *		ޥץå⥸塼
 *		깽¤Ѥޥ
 */

#ifndef TOPPERS_MP_H
#define TOPPERS_MP_H

#include <queue.h>
#include "time_event.h"

/*
 *  
 */
typedef struct task_initialization_block TINIB;
typedef struct task_control_block TCB;

/*
 *		ץå֥å
 */
typedef struct processor_control_block {
	/*
	 *  ץåID
	 */
	ID		 prcid;

	/*
	 *  ͥư֥ե饰
	 *
	 *  ȥåץ롼ǡfalseʡ0ˤ˽뤳ȤԤ
	 *  롥
	 */
	bool_t	 kerflg;

#if TTYPE_KLOCK != G_KLOCK
	/*
	 *  å
	 */
	TSKLOCK	 tsk_lock;
#endif /* TTYPE_KLOCK != G_KLOCK */

#if TTYPE_KLOCK == P_KLOCK
	/*
	 *  ֥ȥå
	 */
	OBJLOCK	 obj_lock;
#endif /* TTYPE_KLOCK == P_KLOCK */

	/*
	 *		Ϣ
	 */

	/*
	 *  ¹Ծ֤Υ
	 *
	 *  ¹Ծ֤ΥʡץåƥȤäƤ륿ˤ
	 *  TCBؤݥ󥿡¹Ծ֤ΥʤNULLˤ롥
	 *
	 *  ӥνǡʥӥƤӽФ
	 *  ˤ˴ؤ򻲾Ȥp_runtskȤp_runtsk񤭴
	 *  ΤϡǥѥåʤȽˤΤߤǤ롥
	 */
	TCB		 *p_runtsk;

	/*
	 *  ǹ̤ͥΥ
	 *
	 *  ¹ԤǤ륿Ǻǹ̤ͥΥTCBؤݥ󥿡
	 *  ԤǤ륿ʤNULLˤ롥
	 *
	 *  ǥѥåػ߾֤ʤɡǥѥåαƤ֤p_runtsk
	 *  ȰפƤȤϸ¤ʤ
	 */
	TCB		 *p_schedtsk;

	/*
	 *  ǥѥå㳰롼ư׵ե饰
	 *
	 *  ߥϥɥ顿CPU㳰ϥɥνиˡǥѥåޤ
	 *  㳰롼εư׵᤹뤳Ȥ򼨤ե饰
	 */
	bool_t	 reqflg;

	/*
	 *  ǥѥåػ߾
	 *
	 *  ǥѥåػ߾֤Ǥ뤳Ȥ򼨤ե饰
	 */
	bool_t	 disdsp;

	/*
	 *  ǥѥåǽ
	 *
	 *  ǥѥåػ߾֤Ǥʤͥ٥ޥIPMˤTIPM_ENAALL
	 *  Ǥ뤳Ȥ򼨤ե饰
	 */
	bool_t	 dspflg;

	/*
	 *  ԥåƤ뤫
	 *
	 *  ԥåƤʤ'0'ԥåƤС
	 *  Ƥ륹ԥåIDݻ롥
	 */
	ID		locspnid;

	/*
	 *  ǥ塼
	 *
	 *  ǥ塼ϡ¹ԤǤ֤Υ뤿Υ塼Ǥ롥
	 *  ¹Ծ֤ΥƤ뤿ᡤǥʼ¹Բǽ˥塼Ȥ
	 *  ̾ΤΤǤϤʤǥ塼Ȥ̾Τ夷Ƥ뤿ᡤ
	 *  ̾ΤǸƤ֤Ȥˤ롥
	 *
	 *  ǥ塼ϡͥ٤ȤΥ塼ǹƤ롥
	 *  TCBϡͥ٤Υ塼Ͽ롥
	 */
	QUEUE	 ready_queue[TNUM_TPRI];

	/*
	 *  ǥ塼ΤΥӥåȥޥå
	 *
	 *  ǥ塼ΥΨ褯Ԥˡͥ٤ȤΥ塼
	 *  ˥äƤ뤫ɤ򼨤ӥåȥޥåפѰդƤ롥ӥ
	 *  ȥޥåפȤȤǡꥢβ򸺤餹ȤǤ뤬
	 *  ӥå̿᤬¤Ƥʤץåǡͥ٤ʳʤ
	 *  ˤϡӥåȥޥåΥСإåɤΤˡդ˸Ψ
	 *  ǽ⤢롥
	 */
	uint16_t ready_primap;

	/*
	 *  ।٥ȥȥ֥åؤΥݥ
	 */ 
	TEVTCB   *p_tevtcb;
}PCB;

/*
 *  ץåIDץåINDEXؤѴ
 */
#define INDEX_PRC(prcid)	((uint_t)((prcid) - TMIN_PRCID))

/*
 *  ץåINDEXץåIDؤѴ
 */
#define ID_PRC(prcindex)	((uint_t)((prcindex) + TMIN_PRCID))

/*
 *  PCBؤΥơ֥kernel_cfg.c
 */
extern PCB* const p_pcb_table[];

/*
 *  ץå PCB ؤΥ
 */
#ifndef my_p_pcb
#define my_p_pcb	(p_pcb_table[x_prc_index()])
#endif /* my_p_pcb */

/*
 *  ¾Υץå PCB ؤΥ
 */
#define mp_pcb(id)	(p_pcb_table[INDEX_PRC(id)])

/*
 *  ưν
 */
extern void initialize_pcb(void);

/*
 *  ץåֳߥϥɥ
 */
extern void ipi_handler(void);

#ifndef OMIT_KER_REQ_ON_IPI
/*
 *  λ׵ե饰
 */
extern bool_t ext_ker_reqflg;

/*
 *  λ׵
 */
extern void ext_ker_request(void);
#endif /* OMIT_KER_REQ_ON_IPI */

#ifndef OMIT_BARRIER_SYNC
/*
 *  ХꥢƱ
 */
extern void barrier_sync(uint_t phase);
#endif  /* OMIT_BARRIER_SYNC */

/*
 *		⥸塼Ϣ
 */

/*
 *  ץå PCB γǤؤΥ
 */
#define my_p_runtsk         (my_p_pcb->p_runtsk)
#define my_p_schedtsk       (my_p_pcb->p_schedtsk)
#define my_reqflg           (my_p_pcb->reqflg)
#define my_disdsp           (my_p_pcb->disdsp)
#define my_dspflg           (my_p_pcb->dspflg)
#define my_locspnid         (my_p_pcb->locspnid)
#define my_ready_queue      (my_p_pcb->ready_queue)
#define my_ready_primap     (my_p_pcb->ready_primap)
#define my_kerflg           (my_p_pcb->kerflg)

/*
 *  ¾ץå PCB γǤؤΥ
 */
#define mp_p_runtsk(id)     ((mp_pcb(id))->p_runtsk)
#define mp_p_schedtsk(id)   ((mp_pcb(id))->p_schedtsk)
#define mp_reqflg(id)       ((mp_pcb(id))->reqflg)
#define mp_disdsp(id)       ((mp_pcb(id))->disdsp)
#define mp_dspflg(id)       ((mp_pcb(id))->dspflg)
#define mp_ready_queue(id)  ((mp_pcb(id))->ready_queue)
#define mp_ready_primap(id) ((mp_pcb(id))->ready_primap)
#define mp_kerflg           ((mp_pcb(id))->kerflg)

/*
 *  ǥѥå׵
 */
extern bool_t dispatch_request(PCB* p_pcb);

/*
 *		।٥ȥ⥸塼Ϣ
 */
#ifdef TOPPERS_SYSTIM_LOCAL

/*
 * 륿ޤξ
 */

/*
 *  ।٥ȥҡפؤΥơ֥kernel_cfg.c
 */
extern TMEVTN* const p_tmevt_heap_table[];

/*
 *  Υ।٥ȥҡפؤΥ
 */
#define my_tmevt_heap  p_tmevt_heap_table[x_prc_index()]

/*
 *  TEVTCB ؤΥơ֥kernel_cfg.c
 */
extern TEVTCB* const p_tevtcb_table[];

/*
 *  ץå TEVTCB ؤΥ
 */
#define my_p_tevtcb (p_tevtcb_table[x_prc_index()])

#else /* TOPPERS_SYSTIM_GLOBAL */

/*
 * Х륿ޤξ
 */

/*
 * 㥤ȥåʳξϥ顼Ȥ
 */
#if TTYPE_KLOCK != G_KLOCK
#error Global timer only support with global lock.
#endif /* TTYPE_KLOCK != G_KLOCK */

/*
 *  ।٥ȥҡסkernel_cfg.c
 */
extern TMEVTN	tmevt_heap[];

/*
 *  ।٥ȥҡפؤΥ
 */
#define my_tmevt_heap  (tmevt_heap)

/*
 *  TEVTCBkernel_cfg.c
 */
extern TEVTCB tevtcb;

/*
 *  ץå TEVTCB ؤΥ
 */
#define my_p_tevtcb (&tevtcb)

#endif /* TOPPERS_SYSTIM_GLOBAL */

/*
 *  ץå TEVTCB γǤؤΥ(¤)
 */
#define my_systim_offset  (my_p_tevtcb->systim_offset)
#define my_current_time   (my_p_tevtcb->current_time)
#define my_next_time      (my_p_tevtcb->next_time)
#define my_next_subtime   (my_p_tevtcb->next_subtime)
#define my_pend_update    (my_p_tevtcb->pend_update)
#define my_last_index     (my_p_tevtcb->last_index)
#define my_p_tmevt_heap   (my_p_tevtcb->p_tmevt_heap)

/*
 *		åطǽ
 */

#if TTYPE_KLOCK == G_KLOCK
/*
 *  㥤ȥåξ
 */

/*
 *  㥤ȥåѿ
 */
extern GLOCK giant_lock;

/*
 *  CPUå֤ѹʤޥ
 */

/*
 *  å
 */
#define ACQUIRE_TSK_LOCK(p_pcb) 				\
	x_acquire_giant_lock(&giant_lock)

/*
 *  å
 */
#define RELEASE_TSK_LOCK(p_pcb)					\
	x_release_giant_lock(&giant_lock)

/*
 *  ֥ȥå
 */
#define ACQUIRE_OBJ_LOCK(p_wobjcb) 				\
	x_acquire_giant_lock(&giant_lock)

/*
 *  ֥ȥå
 */
#define RELEASE_OBJ_LOCK(p_wobjcb)				\
	x_release_giant_lock(&giant_lock)

/*
 *  CPUå֤ѹޥ
 */

/*
 *  ƥȤǤΥåμ
 */
#define T_ACQUIRE_TSK_LOCK(p_pcb) {					\
	t_lock_cpu();									\
	if (t_acquire_giant_lock(&giant_lock)) {		\
		t_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  ƥȤǤΥåμȥޥ졼Υå
 *
 */
#define T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_pcb)  {	\
	t_lock_cpu();									\
	if (t_acquire_giant_lock(&giant_lock)) {		\
		t_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  ƥȤǤμΥåμȼ¹Ծ֤Υå
 *
 *  CPUå塤åޤǤδ֤˼ξ֤RUNNABLE
 *  ʳѹƤʤå˥å롥ξ֤
 *  ѲƤС٥åƲƥȥ饤롥
 * 
 *  ܥޥλѤϡΥåФξΤߤǤ뤿ᡤ
 *  ϤȤ餺my_p_pcb ФԤ
 *
 *  ޥ졼򡤼ץåΥ󥿥ƥȤ˸
 *  ꤷƤ뤿ᡤCPUåϥޥ졼ȯʤᡤå
 *  Υޥ졼Υåɬפʤ  
 */
#define T_ACQUIRE_TSK_LOCK_AND_CHECK_RUNNABLE() {	\
	t_lock_cpu();									\
	if (t_acquire_giant_lock(&giant_lock)) {		\
		t_unlock_cpu();								\
		goto retry;									\
	}												\
	else if (!TSTAT_RUNNABLE(my_p_runtsk->tstat)) {	\
		t_release_giant_lock(&giant_lock);			\
		t_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  ƥȤǤΥå
 */
#define T_RELEASE_TSK_LOCK(p_pcb) {					\
	t_release_giant_lock(&giant_lock);				\
	t_unlock_cpu();									\
}

/*
 *  ƥȤǤΥ֥ȥåμ
 */
#define T_ACQUIRE_OBJ_LOCK(p_wobjcb) {				\
	t_lock_cpu();									\
	if (t_acquire_giant_lock(&giant_lock)) {		\
		t_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  ƥȤǤΥ֥ȥå
 */
#define T_RELEASE_OBJ_LOCK(p_wobjcb) {				\
	t_release_giant_lock(&giant_lock);				\
	t_unlock_cpu();									\
}

/*
 *  å & ǥѥå
 *
 *  åǥѥåꥯȤХǥѥå㡼
 *  ƤӽФ
 */
#define T_RELEASE_TSK_LOCK_AND_DISPATCH(p_pcb, dspreq) {	\
	t_release_giant_lock(&giant_lock);						\
	if (dspreq == true) {									\
		dispatch();											\
	}														\
	t_unlock_cpu();											\
}

/*
 *  ֥ȥå & ǥѥå
 *
 *  åǥѥåꥯȤХǥѥå㡼
 *  ƤӽФ
 */
#define T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_wobjcb, dspreq) {	\
	t_release_giant_lock(&giant_lock);						\
	if (dspreq == true) {									\
		dispatch();											\
	}														\
	t_unlock_cpu();											\
}															\

/*
 *  󥿥ƥ
 */

/*
 *  󥿥ƥȤǤΥå
 */
#define I_ACQUIRE_TSK_LOCK(p_pcb) {					\
	i_lock_cpu();									\
	if (i_acquire_giant_lock(&giant_lock)) {		\
		i_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  󥿥ƥȤǤΥå1
 *  ǥåɥåI_ACQUIRE_TSK_LOCK() ʣ
 *  ƤӽФ˻Ѥ 
 */
#define I_ACQUIRE_TSK_LOCK1(p_pcb) {				\
	i_lock_cpu();									\
	if (i_acquire_giant_lock(&giant_lock)) {		\
		i_unlock_cpu();								\
		goto retry1;								\
	}												\
}

/*
 *  󥿥ƥȤǤΥåμȥޥ졼Υå
 */
#define I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_pcb) {	\
	i_lock_cpu();									\
	if (i_acquire_giant_lock(&giant_lock)) {		\
		i_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  󥿥ƥȤǤΥå
 */
#define I_RELEASE_TSK_LOCK(p_pcb) {					\
	i_release_giant_lock(&giant_lock);				\
	i_unlock_cpu();									\
}

/*
 *  󥿥ƥȤǤΥ֥ȥå
 */
#define I_ACQUIRE_OBJ_LOCK(p_wobjcb) {				\
	i_lock_cpu();									\
	if (i_acquire_giant_lock(&giant_lock)) {		\
		i_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  󥿥ƥȤǤΥ֥ȥå
 */
#define I_RELEASE_OBJ_LOCK(p_wobjcb) {				\
	i_release_giant_lock(&giant_lock);				\
	i_unlock_cpu();									\
}

/*
 *  CPUå֤ѹʤܤΥåȥޥ졼
 *  Υåޥ
 */
#define ACQUIRE_NESTED_TSK_LOCK_AND_CHECK_MIG(p_pcb)

/*
 *  ƥȤǤܤΥå
 */
#define T_ACQUIRE_NESTED_LOCK(p_pcb, p_wobjcb)

/*
 *  ƥȤǤܤΥåȥޥ졼
 *  å
 */
#define T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_pcb, p_wobjcb)

/*
 *  ƥȤǤܤμΥåμȼ¹Ծ
 *  Υå
 * 
 *  ܥޥλѤϡΥåФξΤߤǤ
 *  ᡤϤȤ餺my_p_pcb ФԤ
 */
#define T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(p_wobjcb) {	\
	if(!TSTAT_RUNNABLE(my_p_runtsk->tstat)){					\
		t_release_giant_lock(&giant_lock);						\
		t_unlock_cpu();											\
		goto retry;												\
	}															\
}

/*
 *  ƥȤǤܤΥåޥ
 */ 
#define T_RELEASE_NESTED_LOCK(p_pcb)

/* 
 *  󥿥ƥȤǤܤΥåޥ
 */
#define I_ACQUIRE_NESTED_LOCK(p_pcb, p_wobjcb)

/* 
 *  󥿥ƥȤǤܤΥåȥޥ졼
 *  åޥ
 */
#define I_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_pcb, p_wobjcb)

/*
 *  󥿥ƥȤǤܤΥåޥ
 */
#define I_RELEASE_NESTED_LOCK(p_pcb)

/*
 *  ƥȤĤΥå
 */
#define T_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(f_p_pcb, t_p_pcb) {	\
	t_lock_cpu();									\
	if (t_acquire_giant_lock(&giant_lock)) {		\
		t_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  ƥȤĤΥå
 */
#define T_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb) {	\
	t_release_giant_lock(&giant_lock);				\
	t_unlock_cpu();									\
}

/*
 *  ƥȤĤΥå
 * 
 *  åǥѥåꥯȤХǥѥå㡼
 *  ƤӽФ
 */
#define T_RELEASE_DUAL_TSK_LOCK_AND_DISPATCH(f_p_pcb, t_p_pcb, dspreq) {\
	t_release_giant_lock(&giant_lock);									\
	if (dspreq == true) {												\
		dispatch();														\
	}																	\
	t_unlock_cpu();														\
}

/*
 *  󥿥ƥȤĤΥå
 */
#define I_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(f_p_pcb, t_p_pcb) {	\
	i_lock_cpu();									\
	if (i_acquire_giant_lock(&giant_lock)) {		\
		i_unlock_cpu();								\
		goto retry;									\
	}												\
}

/*
 *  󥿥ƥȤĤΥå
 */
#define I_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb) {	\
		i_release_giant_lock(&giant_lock);			\
		i_unlock_cpu();								\
}

/*
 *  ƥȤĤΥå
 */
#define RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb)		\
		x_release_giant_lock(&giant_lock)


#else /* TTYPE_KLOCK != G_KLOCK */

/*
 *  P_KLOCK or F_KLOCK
 */

/*
 *  ֥ȥȥ֥ååѿμФ
 */
#if TTYPE_KLOCK == P_KLOCK
#define GET_OBJLOCK(p_wobjcb)   (*((WOBJCB*)p_wobjcb)->p_wobjinib->p_obj_lock)
#else /* TTYPE_KLOCK == F_KLOCK */
#define GET_OBJLOCK(p_wobjcb)   (p_wobjcb->obj_lock)
#endif /* TTYPE_KLOCK == F_KLOCK */

/*
 *  CPUå֤ѹʤޥ
 */

/*
 *  å
 */
#define ACQUIRE_TSK_LOCK(p_pcb) 				\
	x_acquire_tsk_lock(&(p_pcb->tsk_lock))

/*
 *  å
 */
#define RELEASE_TSK_LOCK(p_pcb)					\
	x_release_tsk_lock(&(p_pcb->tsk_lock))

/*
 *  ֥ȥå
 */
#define ACQUIRE_OBJ_LOCK(p_wobjcb) 				\
	x_acquire_obj_lock(&(GET_OBJLOCK(p_wobjcb)))	\

/*
 *  ֥ȥå롼
 */
#define RELEASE_OBJ_LOCK(p_wobjcb)				\
	x_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)))

/*
 *  CPUå֤ѹޥ
 */

/*
 *  ƥȤǤΥåμ
 */
#define T_ACQUIRE_TSK_LOCK(p_pcb) {						\
	t_lock_cpu();										\
	if (t_acquire_tsk_lock(&(p_pcb->tsk_lock))) {		\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  ƥȤǤΥåμȥޥ졼Υå
 */
#define T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_pcb) {		\
	PCB* s_p_pcb = p_pcb;								\
	t_lock_cpu();										\
	if (t_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {		\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
	else if (s_p_pcb != p_pcb) {						\
		t_release_tsk_lock(&(s_p_pcb->tsk_lock));		\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  ƥȤǤμΥåμȼ¹Ծ֤Υå
 *
 *  CPUå塤åޤǤδ֤˼ξ֤RUNNABLE
 *  ʳѹƤʤå˥å롥ξ֤
 *  ѲƤС٥åƲƥȥ饤롥
 *
 *  ܥޥλѤϡΥåФξΤߤǤ뤿ᡤ
 *  ϤȤ餺my_p_pcb ФԤ
 *
 *  ޥ졼򡤼ץåΥ󥿥ƥȤ˸
 *  ꤷƤ뤿ᡤCPUåϥޥ졼ȯʤᡤå
 *  Υޥ졼Υåɬפʤ
 */
#define T_ACQUIRE_TSK_LOCK_AND_CHECK_RUNNABLE() {		\
	t_lock_cpu();										\
	if (t_acquire_tsk_lock(&(my_p_pcb->tsk_lock))) {	\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
	else if (!TSTAT_RUNNABLE(my_p_runtsk->tstat)) {		\
		t_release_tsk_lock(&(my_p_pcb->tsk_lock));		\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  ƥȤǤΥåޥ
 */
#define T_RELEASE_TSK_LOCK(p_pcb) {						\
	t_release_tsk_lock(&(p_pcb->tsk_lock));				\
	t_unlock_cpu();										\
}

/*
 *  ƥȤǤΥ֥ȥåμ
 */
#define T_ACQUIRE_OBJ_LOCK(p_wobjcb) {					\
	t_lock_cpu();										\
	if (t_acquire_obj_lock(&(GET_OBJLOCK(p_wobjcb)))) {	\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  ƥȤǤΥ֥ȥåޥ
 */
#define T_RELEASE_OBJ_LOCK(p_wobjcb) {				\
	t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
	t_unlock_cpu();									\
}

/*
 *  å & ǥѥåޥ
 *
 *  åǥѥåꥯȤХǥѥå㡼
 *  ƤӽФ
 */
#define T_RELEASE_TSK_LOCK_AND_DISPATCH(p_pcb, dspreq) {	\
	t_release_tsk_lock(&(p_pcb->tsk_lock));					\
	if (dspreq == true) {									\
		dispatch();											\
	}														\
	t_unlock_cpu();											\
}															\

/*
 *  ֥ȥå & ǥѥåޥ
 *
 *  åǥѥåꥯȤХǥѥå㡼
 *  ƤӽФ
 */
#define T_RELEASE_OBJ_LOCK_AND_DISPATCH(p_wobjcb, dspreq) {	\
	t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));			\
	if (dspreq == true) {									\
		dispatch();											\
	}														\
	t_unlock_cpu();											\
}															\


/*
 *  󥿥ƥ
 */

/*
 *  󥿥ƥȤǤΥåޥ
 */
#define I_ACQUIRE_TSK_LOCK(p_pcb) {						\
	i_lock_cpu();										\
	if (i_acquire_tsk_lock(&(p_pcb->tsk_lock))) {		\
		i_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  󥿥ƥȤǤΥåޥ1
 *  ǥåɥåI_ACQUIRE_TSK_LOCK() ʣ
 *  ƤӽФ˻Ѥ
 */
#define I_ACQUIRE_TSK_LOCK1(p_pcb) {					\
	i_lock_cpu();										\
	if (i_acquire_tsk_lock(&(p_pcb->tsk_lock))) {		\
		i_unlock_cpu();									\
		goto retry1;									\
	}													\
}

/*
 *  ƥȤǤΥåμȥޥ졼Υå
 */
#define I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_pcb) {		\
	PCB* s_p_pcb = p_pcb;								\
	i_lock_cpu();										\
	if (i_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {		\
		i_unlock_cpu();									\
		goto retry;										\
	}													\
	else if (s_p_pcb != p_pcb) {						\
		i_release_tsk_lock(&(s_p_pcb->tsk_lock));		\
		i_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  󥿥ƥȤǤΥåޥ
 */
#define I_RELEASE_TSK_LOCK(p_pcb) {						\
	i_release_tsk_lock(&(p_pcb->tsk_lock));				\
	i_unlock_cpu();										\
}

/*
 *  󥿥ƥȤǤΥ֥ȥåޥ
 */
#define I_ACQUIRE_OBJ_LOCK(p_wobjcb) {					\
	i_lock_cpu();										\
	if (i_acquire_obj_lock(&(GET_OBJLOCK(p_wobjcb)))) {	\
		i_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  󥿥ƥȤǤΥ֥ȥåޥ
 */
#define I_RELEASE_OBJ_LOCK(p_wobjcb) {					\
	i_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));		\
	i_unlock_cpu();										\
}

/*
 *  CPUå֤ѹʤܤΥåȥޥ졼
 *  Υåޥ
 */
#define ACQUIRE_NESTED_TSK_LOCK_AND_CHECK_MIG(p_pcb) {	\
  retry_a_n_t_l_a_c_m:									\
	{													\
		PCB* s_p_pcb = p_pcb;							\
		while (x_acquire_tsk_lock(&(p_pcb->tsk_lock)));\
		if (s_p_pcb != p_pcb) {							\
			x_release_tsk_lock(&(s_p_pcb->tsk_lock));	\
			goto retry_a_n_t_l_a_c_m;					\
		}												\
	}													\
}

/*
 *  ƥȤǤܤΥåޥ
 */
#define T_ACQUIRE_NESTED_LOCK(p_pcb, p_wobjcb) {		\
	if (t_acquire_tsk_lock(&(p_pcb->tsk_lock))) {		\
		t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  ƥȤǤܤΥåȥޥ졼
 *  åޥ
 */
#define T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_pcb, p_wobjcb) {	\
	PCB* s_p_pcb = p_pcb;										\
	if (t_acquire_tsk_lock(&(p_pcb->tsk_lock))) {				\
		t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));			\
		t_unlock_cpu();											\
		goto retry;												\
	}															\
	else if (s_p_pcb != p_pcb) {								\
		t_release_tsk_lock(&(s_p_pcb->tsk_lock));				\
		t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));			\
		t_unlock_cpu();											\
		goto retry;												\
	}															\
}

/*
 *  ƥȤǤܤμΥåμȼ¹Ծ
 *  Υåޥ
 * 
 *  CPUå塤åޤǤδ֤˼ξ֤RUNNABLE
 *  ʳѹƤʤå롥ξ֤ѲƤС
 *  åƲƥȥ饤롥
 * 
 *  ܥޥλѤϡΥåФξΤߤǤ
 *  ᡤϤȤ餺my_p_pcb ФԤ
 */
#define T_ACQUIRE_NESTED_LOCK_AND_CHECK_RUNNABLE(p_wobjcb) {	\
	if (t_acquire_tsk_lock(&(my_p_pcb->tsk_lock))) {			\
		t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));			\
		t_unlock_cpu();											\
		goto retry;												\
	}															\
	else if(!TSTAT_RUNNABLE(my_p_runtsk->tstat)){				\
		t_release_tsk_lock(&(my_p_pcb->tsk_lock));				\
		t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));			\
		t_unlock_cpu();											\
		goto retry;												\
	}															\
}

/*
 *  ƥȤǤܤΥåޥ
 *
 *  ξΥåƱ˲ΤǤϤʤ
 */ 
#define T_RELEASE_NESTED_LOCK(p_pcb) {				\
	t_release_tsk_lock(&(p_pcb->tsk_lock));			\
}

/* 
 *  󥿥ƥȤǤܤΥåޥ
 */
#define I_ACQUIRE_NESTED_LOCK(p_pcb, p_wobjcb) {		\
	if (i_acquire_tsk_lock(&(p_pcb->tsk_lock))) {		\
		i_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
		i_unlock_cpu();									\
		goto retry;										\
	}													\
}

/* 
 *  󥿥ƥȤǤܤΥåȥޥ졼
 *  åޥ
 */
#define I_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_pcb, p_wobjcb) {	\
	PCB* s_p_pcb = p_pcb;										\
	if (i_acquire_tsk_lock(&(p_pcb->tsk_lock))) {				\
		i_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));			\
		i_unlock_cpu();											\
		goto retry;												\
	}															\
	else if (s_p_pcb != p_pcb) {								\
		i_release_tsk_lock(&(s_p_pcb->tsk_lock));				\
		i_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));			\
		i_unlock_cpu();											\
		goto retry;												\
	}															\
}

/*
 *  󥿥ƥȤǤܤΥåޥ
 */
#define I_RELEASE_NESTED_LOCK(p_pcb) {					\
	i_release_tsk_lock(&(p_pcb->tsk_lock));				\
}

/*
 *  ƥȤĤΥåμȡޥ졼Υ
 *  å
 */
#define T_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(f_p_pcb, t_p_pcb) {		\
	PCB* s_p_pcb = f_p_pcb;								\
	t_lock_cpu();										\
	if (s_p_pcb->prcid > t_p_pcb->prcid) {				\
		if (t_acquire_tsk_lock(&(t_p_pcb->tsk_lock))) {	\
			t_unlock_cpu();								\
			goto retry;									\
		}												\
		if (t_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {	\
			t_release_tsk_lock(&(t_p_pcb->tsk_lock));	\
			t_unlock_cpu();								\
			goto retry;									\
		}												\
	}													\
	else if (s_p_pcb->prcid < t_p_pcb->prcid) {			\
		if (t_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {	\
			t_unlock_cpu();								\
			goto retry;									\
		}												\
		if (t_acquire_tsk_lock(&(t_p_pcb->tsk_lock))) {	\
			t_release_tsk_lock(&(s_p_pcb->tsk_lock));	\
			t_unlock_cpu();								\
			goto retry;									\
		}												\
	}													\
	else {												\
		if (t_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {	\
			t_unlock_cpu();								\
			goto retry;									\
		}												\
	}													\
	if (s_p_pcb != f_p_pcb) {							\
		t_release_tsk_lock(&(t_p_pcb->tsk_lock));		\
		if (s_p_pcb->prcid != t_p_pcb->prcid) {			\
			t_release_tsk_lock(&(s_p_pcb->tsk_lock));	\
		}												\
		t_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  ƥȤĤΥå
 */
#define T_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb) {		\
	if (f_p_pcb != t_p_pcb) {							\
		t_release_tsk_lock(&(f_p_pcb->tsk_lock));		\
	}													\
	t_release_tsk_lock(&(t_p_pcb->tsk_lock));			\
	t_unlock_cpu();										\
}

/*
 *  ƥȤĤΥå
 *
 *  åǥѥåꥯȤХǥѥå㡼
 *  ƤӽФ
 */
#define T_RELEASE_DUAL_TSK_LOCK_AND_DISPATCH(f_p_pcb, t_p_pcb, dspreq) {\
	if (f_p_pcb != t_p_pcb) {											\
		t_release_tsk_lock(&(f_p_pcb->tsk_lock));						\
	}																	\
	t_release_tsk_lock(&(t_p_pcb->tsk_lock));							\
	if (dspreq == true) {												\
		dispatch();														\
	}																	\
	t_unlock_cpu();														\
}

/*
 *  ƥȤܤĤΥåμȡޥ졼
 *  Υå
 */
#define T_ACQUIRE_NESTED_DUAL_LOCK_AND_CHECK_MIG(f_p_pcb, t_p_pcb, p_wobjcb) {\
	PCB* s_p_pcb = f_p_pcb;									\
	if (s_p_pcb->prcid > t_p_pcb->prcid) {					\
		if (t_acquire_tsk_lock(&(t_p_pcb->tsk_lock))) {		\
			t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
			t_unlock_cpu();									\
			goto retry;										\
		}													\
		if (t_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {		\
			t_release_tsk_lock(&(t_p_pcb->tsk_lock));		\
			t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
			t_unlock_cpu();									\
			goto retry;										\
		}													\
	}														\
	else if (s_p_pcb->prcid < t_p_pcb->prcid) {				\
		if (t_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {		\
			t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
			t_unlock_cpu();									\
			goto retry;										\
		}													\
		if (t_acquire_tsk_lock(&(t_p_pcb->tsk_lock))) {		\
			t_release_tsk_lock(&(s_p_pcb->tsk_lock));		\
			t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
			t_unlock_cpu();									\
			goto retry;										\
		}													\
	}														\
	else {													\
		if (t_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {		\
			t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
			t_unlock_cpu();									\
			goto retry;										\
		}													\
	}														\
	if (s_p_pcb != f_p_pcb) {								\
		t_release_tsk_lock(&(t_p_pcb->tsk_lock));			\
		if (s_p_pcb->prcid != t_p_pcb->prcid) {				\
			t_release_obj_lock(&(GET_OBJLOCK(p_wobjcb)));	\
			t_release_tsk_lock(&(s_p_pcb->tsk_lock));		\
		}													\
		t_unlock_cpu();										\
		goto retry;											\
	}														\
}

/*
 *  󥿥ƥȤĤΥåμȡޥ졼Υ
 *  å
 */
#define I_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(f_p_pcb, t_p_pcb) {		\
	i_lock_cpu();										\
	PCB* s_p_pcb = f_p_pcb;								\
	if (s_p_pcb->prcid > t_p_pcb->prcid) {				\
		if (i_acquire_tsk_lock(&(t_p_pcb->tsk_lock))) {	\
			i_unlock_cpu();								\
			goto retry;									\
		}												\
		if (i_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {	\
			i_release_tsk_lock(&(t_p_pcb->tsk_lock));	\
			i_unlock_cpu();								\
			goto retry;									\
		}												\
	}													\
	else if (s_p_pcb->prcid < t_p_pcb->prcid) {			\
		if (i_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {	\
			i_unlock_cpu();								\
			goto retry;									\
		}												\
		if (i_acquire_tsk_lock(&(t_p_pcb->tsk_lock))) {	\
			i_release_tsk_lock(&(s_p_pcb->tsk_lock));	\
			i_unlock_cpu();								\
			goto retry;									\
		}												\
	}													\
	else {												\
		if (i_acquire_tsk_lock(&(s_p_pcb->tsk_lock))) {	\
			i_unlock_cpu();								\
			goto retry;									\
		}												\
	}													\
	if (s_p_pcb != f_p_pcb) {							\
		i_release_tsk_lock(&(t_p_pcb->tsk_lock));		\
		if (s_p_pcb->prcid != t_p_pcb->prcid) {			\
			i_release_tsk_lock(&(s_p_pcb->tsk_lock));	\
		}												\
		i_unlock_cpu();									\
		goto retry;										\
	}													\
}

/*
 *  󥿥ƥȤĤΥå
 */
#define I_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb) {		\
	if (f_p_pcb != t_p_pcb) {							\
		i_release_tsk_lock(&(f_p_pcb->tsk_lock));		\
	}													\
	i_release_tsk_lock(&(t_p_pcb->tsk_lock));			\
	i_unlock_cpu();										\
}

/*
 *  å֤ѹʤåβ
 */
#define RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb) {			\
	if (f_p_pcb != t_p_pcb) {								\
		x_release_tsk_lock(&(f_p_pcb->tsk_lock));			\
	}														\
	x_release_tsk_lock(&(t_p_pcb->tsk_lock));				\
}

#endif /* TTYPE_KLOCK != G_KLOCK */

#endif /* TOPPERS_MP_H */
