/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: task.c 338 2009-07-29 04:17:23Z ertl-honda $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "wait.h"
#include "task.h"
#include "spin_lock.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_TEX_ENTER
#define LOG_TEX_ENTER(p_tcb, texptn)
#endif /* LOG_TEX_ENTER */

#ifndef LOG_TEX_LEAVE
#define LOG_TEX_LEAVE(p_tcb, texptn)
#endif /* LOG_TEX_LEAVE */

#ifdef TOPPERS_tskini

/*
 *  ⥸塼ν
 */
void
initialize_task(void)
{
	uint_t	i, j;
	TCB		*p_tcb;

	for (i = 0; i < tnum_tsk; i++) {
		j = INDEX_TSK(torder_table[i]);
		/* ˳դ줿ν */
		if (tinib_table[j].iaffinity == ID_PRC(x_prc_index())) {
			p_tcb = p_tcb_table[j];
			p_tcb->p_tinib = &(tinib_table[j]);
			p_tcb->actque = false;
			p_tcb->actprc = 0U;
			p_tcb->p_pcb = my_p_pcb;
			make_dormant(p_tcb);
			if ((p_tcb->p_tinib->tskatr & TA_ACT) != 0U) {
				make_active(p_tcb);
			}
		}
	}
}

#endif /* TOPPERS_tskini */

/*
 *  ӥåȥޥåץؿ
 *
 *  bitmap1ΥӥåȤ⡤ǤⲼ̡ʱˤΤΤ򥵡Υӥ
 *  ֹ֤ӥåֹϡǲ̥ӥåȤ0Ȥ롥bitmap0
 *  ƤϤʤʤδؿǤϡbitmap16ӥåȤǤ뤳Ȥꤷ
 *  uint16_tȤƤ롥
 *
 *  ӥåȥ̿ĥץåǤϡӥåȥ̿Ȥ褦
 *  ľΨɤ礬롥Τ褦ʾˤϡå
 *  ¸ǥӥåȥ̿Ȥäbitmap_search
 *  OMIT_BITMAP_SEARCHޥФ褤ޤӥåȥ̿
 *  դʤɤͳͥ٤ȥӥåȤȤбѹ
 *  ϡPRIMAP_BITޥФ褤
 *
 *  ޤɸ饤֥ffsʤ顤Τ褦ɸ饤
 *  ȤäΨɤǽ⤢롥
 *		#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define	PRIMAP_BIT(pri)		(1U << (pri))
#endif /* PRIMAP_BIT */

#ifndef OMIT_BITMAP_SEARCH

static const unsigned char bitmap_search_table[] = { 0, 1, 0, 2, 0, 1, 0,
												3, 0, 1, 0, 2, 0, 1, 0 };

Inline uint_t
bitmap_search(uint16_t bitmap)
{
	uint_t	n = 0U;

	assert(bitmap != 0U);
	if ((bitmap & 0x00ffU) == 0U) {
		bitmap >>= 8;
		n += 8;
	}
	if ((bitmap & 0x0fU) == 0U) {
		bitmap >>= 4;
		n += 4;
	}
	return(n + bitmap_search_table[(bitmap & 0x0fU) - 1]);
}

#endif /* OMIT_BITMAP_SEARCH */

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
Inline bool_t
primap_empty(PCB *p_pcb)
{
	return(p_pcb->ready_primap == 0U);
}

/*
 *  ͥ٥ӥåȥޥåפΥ
 */
Inline uint_t
primap_search(PCB *p_pcb)
{
	return(bitmap_search(p_pcb->ready_primap));
}

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
Inline void
primap_set(PCB *p_pcb, uint_t pri)
{
	p_pcb->ready_primap |= PRIMAP_BIT(pri);
}

/*
 *  ͥ٥ӥåȥޥåפΥꥢ
 */
Inline void
primap_clear(PCB *p_pcb, uint_t pri)
{
	p_pcb->ready_primap &= ~PRIMAP_BIT(pri);
}

/*
 *  ǹ̥ͥΥ
 */
#ifdef TOPPERS_tsksched

TCB *
search_schedtsk(PCB *p_pcb)
{
	uint_t	schedpri;

	schedpri = primap_search(p_pcb);
	return((TCB *)((p_pcb->ready_queue)[schedpri].p_next));
}

#endif /* TOPPERS_tsksched */

/*
 *  ¹ԤǤ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡ¹ԤǤ륿ʤä
 *  ȡp_tcbͥ٤ǹ̤ͥΥͥ٤⤤Ǥ
 *  롥
 */
#ifdef TOPPERS_tskrun

bool_t
make_runnable(TCB *p_tcb)
{
	uint_t	pri = p_tcb->priority;

	queue_insert_prev(&((p_tcb->p_pcb->ready_queue)[pri]), &(p_tcb->task_queue));
	primap_set(p_tcb->p_pcb, pri);

	if (p_tcb->p_pcb->p_schedtsk == (TCB *) NULL
		|| pri < p_tcb->p_pcb->p_schedtsk->priority) {
		p_tcb->p_pcb->p_schedtsk = p_tcb;
		return(p_tcb->p_pcb->dspflg);
	}
	return(false);
}

#endif /* TOPPERS_tskrun */

/*
 *  ¹ԤǤ֤¾ξ֤ؤΰܹ
 *
 *  ǹ̤ͥΥ򹹿Τϡp_tcbǹ̤ͥΥ
 *  äǤ롥p_tcbƱͥ٤Υ¾ˤϡp_tcb
 *  μΥǹ̤ͥˤʤ롥Ǥʤϡǥ塼
 *  ɬפ롥
 */
#ifdef TOPPERS_tsknrun

bool_t
make_non_runnable(TCB *p_tcb)
{
	uint_t	pri = p_tcb->priority;
	QUEUE	*p_queue = &((p_tcb->p_pcb->ready_queue)[pri]);

	queue_delete(&(p_tcb->task_queue));
	if (queue_empty(p_queue)) {
		primap_clear(p_tcb->p_pcb,pri);
		if (p_tcb->p_pcb->p_schedtsk == p_tcb) {
			p_tcb->p_pcb->p_schedtsk = primap_empty(p_tcb->p_pcb) ? (TCB *) NULL : search_schedtsk(p_tcb->p_pcb);
			return(p_tcb->p_pcb->dspflg);
		}
	}
	else {
		if (p_tcb->p_pcb->p_schedtsk == p_tcb) {
			p_tcb->p_pcb->p_schedtsk = (TCB *)(p_queue->p_next);
			return(p_tcb->p_pcb->dspflg);
		}
	}
	return(false);
}

#endif /* TOPPERS_tsknrun */

/*
 *  ٻ߾֤ؤΰܹ
 */
#ifdef TOPPERS_tskdmt

void
make_dormant(TCB *p_tcb)
{
	p_tcb->tstat = TS_DORMANT;
	p_tcb->priority = p_tcb->p_tinib->ipriority;
	p_tcb->wupque = false;
	p_tcb->enatex = false;
	p_tcb->texptn = 0U;
#if TTYPE_KLOCK != G_KLOCK
	p_tcb->pend_relwai = false;
	p_tcb->pend_chgpri = false;
#endif /* TTYPE_KLOCK != G_KLOCK */
	LOG_TSKSTAT(p_tcb);
}

#endif /* TOPPERS_tskdmt */

/*
 *  ٻ߾֤¹ԤǤ֤ؤΰܹ
 */
#ifdef TOPPERS_tskact

bool_t
make_active(TCB *p_tcb)
{
	activate_context(p_tcb);
	p_tcb->tstat = TS_RUNNABLE;
	LOG_TSKSTAT(p_tcb);
	return(make_runnable(p_tcb));
}

#endif /* TOPPERS_tskact */

/*
 *  ͥ٤ѹ
 *
 *  ¹ԤǤ֤ξˤϡǥ塼Ǥΰ֤ѹ
 *  롥֥ȤԤ塼Ԥ֤ˤʤäƤˤϡ
 *  塼Ǥΰ֤ѹ롥
 *
 *  ǹ̤ͥΥ򹹿Τϡ(1) p_tcbǹ̤ͥΥ
 *  Ǥäơͥ٤򲼤硤(2) p_tcbǹ̤ͥΥ
 *  ǤϤʤѹͥ٤ǹ̤ͥΥͥ٤⤤
 *  Ǥ롥(1)ξˤϡǥ塼򥵡ɬפ롥
 */
#ifdef TOPPERS_tskpri

bool_t
change_priority(TCB *p_tcb, uint_t newpri)
{
	uint_t	oldpri;

	oldpri = p_tcb->priority;
	p_tcb->priority = newpri;

	if (TSTAT_RUNNABLE(p_tcb->tstat)) {
		/*
		 *  ¹ԤǤ֤ξ
		 */
		queue_delete(&(p_tcb->task_queue));
		if (queue_empty(&((p_tcb->p_pcb->ready_queue)[oldpri]))) {
			primap_clear(p_tcb->p_pcb, oldpri);
		}
		queue_insert_prev(&((p_tcb->p_pcb->ready_queue)[newpri]), &(p_tcb->task_queue));
		primap_set(p_tcb->p_pcb, newpri);

		if (p_tcb->p_pcb->p_schedtsk == p_tcb) {
			if (newpri >= oldpri) {
				p_tcb->p_pcb->p_schedtsk = search_schedtsk(p_tcb->p_pcb);
				return(p_tcb->p_pcb->p_schedtsk != p_tcb && p_tcb->p_pcb->dspflg);
			}
		}
		else {
			if (newpri < p_tcb->p_pcb->p_schedtsk->priority) {
				p_tcb->p_pcb->p_schedtsk = p_tcb;
				return(p_tcb->p_pcb->dspflg);
			}
		}
	}
	else {
		if (TSTAT_WAIT_WOBJCB(p_tcb->tstat)) {
			/*
			 *  Ʊ֥̿Ȥδ֥åζ
			 *  ʬWOBJCBˤԤ塼ˤĤʤƤ
			 */
			wobj_change_priority(p_tcb->p_wobjcb, p_tcb);
		}
	}
	return(false);
}

#endif /* TOPPERS_tskpri */

/*
 *  ǥ塼βž
 *
 *  ǹ̤ͥΥ򹹿Τϡǹ̤ͥΥ
 *  塼˰ưǤ롥
 *
 */
#ifdef TOPPERS_tskrot

bool_t
rotate_ready_queue(uint_t pri, PCB *p_pcb)
{
	QUEUE	*p_queue = &((p_pcb->ready_queue)[pri]);
	QUEUE	*p_entry;

	if (!queue_empty(p_queue) && p_queue->p_next->p_next != p_queue) {
		p_entry = queue_delete_next(p_queue);
		queue_insert_prev(p_queue, p_entry);
		if (p_pcb->p_schedtsk == (TCB *) p_entry) {
			p_pcb->p_schedtsk = (TCB *)(p_queue->p_next);
			return(p_pcb->dspflg);
		}
	}
	return(false);
}

#endif /* TOPPERS_tskrot */

/*
 *  㳰롼θƽФ
 *
 *  FMPͥǤϡ㳰롼CPUå֤˰ܹԤ
 *  ξ֤ᤵ˥꥿󤷤硤ͥ뤬ξ֤᤹
 */
#ifdef TOPPERS_tsktex
#ifndef OMIT_CALL_TEXRTN

/*
 *  call_texrtn  dispatch() θƤӽФ
 *  åޥο䤷ʤᡤ̴ؿȤ롥
 *  åƸƤӽФ꥿Ƽ롥
 */
Inline void
call_texrtn_to_dispatch(void)
{
	RELEASE_TSK_LOCK(my_p_pcb);
	dispatch();
  retry:
	T_ACQUIRE_TSK_LOCK(my_p_pcb);
}

/*
 *  ץåФƸƤӽФ
 */
void
call_texrtn(void)
{
	TEXPTN	texptn;
	PRI		saved_ipm;
	bool_t	saved_disdsp, saved_dspflg;

	saved_ipm = t_get_ipm();
	saved_disdsp = my_disdsp;
	saved_dspflg = my_dspflg;
	do {
		texptn = my_p_runtsk->texptn;
		my_p_runtsk->enatex = false;
		my_p_runtsk->texptn = 0U;
		T_RELEASE_TSK_LOCK(my_p_pcb);
		LOG_TEX_ENTER(my_p_runtsk, texptn);
		(*((TEXRTN)(my_p_runtsk->p_tinib->texrtn)))(texptn,
												my_p_runtsk->p_tinib->exinf);
		LOG_TEX_LEAVE(my_p_runtsk, texptn);

		if (t_sense_lock()) {
			t_unlock_cpu();
		}

	  retry:
		T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(my_p_pcb);
		t_set_ipm(saved_ipm);
		my_disdsp = saved_disdsp;
		my_dspflg = saved_dspflg;
		force_unlock_spin();
		if (my_p_runtsk != my_p_schedtsk && my_dspflg) {
			call_texrtn_to_dispatch();
		}
	} while (my_p_runtsk->texptn != 0U);
	my_p_runtsk->enatex = true;
}

/*
 *  ǥѥå㡼Υ㳰롼θƤӽФ
 */
void
dispatch_call_texrtn(void)
{
	t_unlock_cpu();
  retry:
	T_ACQUIRE_TSK_LOCK(my_p_pcb);
	if ((my_p_runtsk->enatex && my_p_runtsk->texptn) != 0) {
		call_texrtn();
	}
	RELEASE_TSK_LOCK(my_p_pcb);
}


#endif /* OMIT_CALL_TEXRTN */

/*
 *  㳰롼εư
 */
#ifndef OMIT_CALLTEX

void
calltex(void)
{
	if (my_p_runtsk->enatex && my_p_runtsk->texptn != 0U) {
		dispatch_call_texrtn();
	}
}

#endif /* OMIT_CALLTEX */
#endif /* TOPPERS_tsktex */

#ifdef TOPPERS_migrate_self

/*
 *  ƥȤǤμФޥ졼
 *
 *  CPUåưȰưΥåμƥ
 *  ¸Τ󥿥ƥȤΥå뤳ȡ 
 */
void
migrate_self(ID prcid)
{
	TCB		*p_tcb;
	PCB		*t_p_pcb;
	PCB		*f_p_pcb;

	p_tcb = my_p_runtsk;

	/* ưΥץåPCB */
	t_p_pcb = mp_pcb(prcid);

	/* åΤ¸ */
	f_p_pcb = p_tcb->p_pcb;

	if (TSTAT_RUNNABLE(p_tcb->tstat)) {
		/* ǥ塼鳰 */
		make_non_runnable(p_tcb);
		/* pcb ν񤭴 */
		p_tcb->p_pcb = t_p_pcb;
		/* ܹΥץåmake_runnable */
		if (make_runnable(p_tcb)) {
			dispatch_request(p_tcb->p_pcb);
		}
	}
	else {
		/*
		 * CPUåĥåƤ뤿
		 * ¾ξ֤ˤϤʤʤ
		 */
		assert(0);
	}
	RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb);
	/* ǥѥå㡼 */
	exit_and_dispatch();
	assert(0);
}

#endif /* TOPPERS_migrate_self */

#ifdef TOPPERS_exit_and_migrate_self

/*
 *  ƥȤǤμФ륳ƥȤ˴
 *  ޥ졼
 *
 *  CPUåưȰưΥåμΤ
 *  󥿥ƥȤΥå뤳ȡ 
 */
void
exit_and_migrate_self(ID prcid)
{
	TCB		*p_tcb;
	PCB		*t_p_pcb;
	PCB		*f_p_pcb;

	p_tcb = my_p_runtsk;

	/* ưΥץåPCB */
	t_p_pcb = mp_pcb(prcid);
	/* åΤ¸ */
	f_p_pcb = p_tcb->p_pcb;

	(void) make_non_runnable(my_p_runtsk);
	make_dormant(my_p_runtsk);
	p_tcb->p_pcb = t_p_pcb;
	my_p_runtsk->actque = false;
	my_p_runtsk->actprc = 0U;
	if (make_active(my_p_runtsk)) {
		dispatch_request(p_tcb->p_pcb);
	}

	RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb);
	/* ǥѥå㡼 */
	exit_and_dispatch();
	assert(0);
}

#endif /* TOPPERS_exit_and_migrate_self */
