/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: task_manage.c 333 2009-07-17 04:13:48Z ertl-honda $
 */

/*
 *		ǽ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "spin_lock.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_MIG_TSK_ENTER
#define LOG_MIG_TSK_ENTER(tskid, prcid)
#endif  /* LOG_MIG_TSK_ENTER */

#ifndef LOG_MIG_TSK_LEAVE
#define LOG_MIG_TSK_LEAVE(ercd)
#endif  /* LOG_MIG_TSK_LEAVE */

#ifndef LOG_ACT_TSK_ENTER
#define LOG_ACT_TSK_ENTER(tskid)
#endif /* LOG_ACT_TSK_ENTER */

#ifndef LOG_ACT_TSK_LEAVE
#define LOG_ACT_TSK_LEAVE(ercd)
#endif /* LOG_ACT_TSK_LEAVE */

#ifndef LOG_IACT_TSK_ENTER
#define LOG_IACT_TSK_ENTER(tskid)
#endif /* LOG_IACT_TSK_ENTER */

#ifndef LOG_IACT_TSK_LEAVE
#define LOG_IACT_TSK_LEAVE(ercd)
#endif /* LOG_IACT_TSK_LEAVE */

#ifndef LOG_MACT_TSK_ENTER
#define LOG_MACT_TSK_ENTER(tskid, prcid)
#endif /* LOG_MACT_TSK_ENTER */

#ifndef LOG_MACT_TSK_LEAVE
#define LOG_MACT_TSK_LEAVE(ercd)
#endif /* LOG_MACT_TSK_LEAVE */

#ifndef LOG_IMACT_TSK_ENTER
#define LOG_IMACT_TSK_ENTER(tskid, prcid)
#endif /* LOG_IMACT_TSK_ENTER */

#ifndef LOG_IMACT_TSK_LEAVE
#define LOG_IMACT_TSK_LEAVE(ercd)
#endif /* LOG_IMACT_TSK_LEAVE */

#ifndef LOG_CAN_ACT_ENTER
#define LOG_CAN_ACT_ENTER(tskid)
#endif /* LOG_CAN_ACT_ENTER */

#ifndef LOG_CAN_ACT_LEAVE
#define LOG_CAN_ACT_LEAVE(ercd)
#endif /* LOG_CAN_ACT_LEAVE */

#ifndef LOG_EXT_TSK_ENTER
#define LOG_EXT_TSK_ENTER()
#endif /* LOG_EXT_TSK_ENTER */

#ifndef LOG_EXT_TSK_LEAVE
#define LOG_EXT_TSK_LEAVE(ercd)
#endif /* LOG_EXT_TSK_LEAVE */

#ifndef LOG_TER_TSK_ENTER
#define LOG_TER_TSK_ENTER(tskid)
#endif /* LOG_TER_TSK_ENTER */

#ifndef LOG_TER_TSK_LEAVE
#define LOG_TER_TSK_LEAVE(ercd)
#endif /* LOG_TER_TSK_LEAVE */

#ifndef LOG_CHG_PRI_ENTER
#define LOG_CHG_PRI_ENTER(tskid, tskpri)
#endif /* LOG_CHG_PRI_ENTER */

#ifndef LOG_CHG_PRI_LEAVE
#define LOG_CHG_PRI_LEAVE(ercd)
#endif /* LOG_CHG_PRI_LEAVE */

#ifndef LOG_GET_PRI_ENTER
#define LOG_GET_PRI_ENTER(tskid, p_tskpri)
#endif /* LOG_GET_PRI_ENTER */

#ifndef LOG_GET_PRI_LEAVE
#define LOG_GET_PRI_LEAVE(ercd, tskpri)
#endif /* LOG_GET_PRI_LEAVE */

#ifndef LOG_GET_INF_ENTER
#define LOG_GET_INF_ENTER(p_exinf)
#endif /* LOG_GET_INF_ENTER */

#ifndef LOG_GET_INF_LEAVE
#define LOG_GET_INF_LEAVE(ercd, exinf)
#endif /* LOG_GET_INF_LEAVE */

/*
 *  ץå¾Υư
 */
#ifdef TOPPERS_mig_tsk

ER
mig_tsk(ID tskid, ID prcid)
{
	TCB		*p_tcb;
	ER		ercd = E_OK;
	PCB		*t_p_pcb;
	PCB		*f_p_pcb;
	bool_t	dspreq = false;
#ifdef TOPPERS_SYSTIM_LOCAL
	EVTTIM	event_time;
#endif /* TOPPERS_SYSTIM_LOCAL */

	LOG_MIG_TSK_ENTER(tskid, prcid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	CHECK_PRCID_INI(prcid);
	p_tcb = get_tcb_self(tskid);
	prcid = (prcid == TPRC_INI)? p_tcb->p_tinib->iaffinity : prcid;
	CHECK_MIG(p_tcb->p_tinib->affinity_mask, prcid);
	/* ưΥץåPCB */
	t_p_pcb = mp_pcb(prcid);

  retry:
	/* ߳դƤץåȰưΥץåΥå */
	T_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, t_p_pcb);
	/* åΤ¸ */
	f_p_pcb = p_tcb->p_pcb;
	if (f_p_pcb != my_p_pcb) {
		/*
		 * Ʊץå˳դƤ륿Ǥʤ
		 * Х顼 mig_tsk ƤӽФƥॳƽФ塤
		 * ޥ졼Ȥ줿ˤ⡤ǥ顼Ȥʤ
		 */
		ercd = E_OBJ;
	}
	else if (TSTAT_RUNNABLE(p_tcb->tstat)){
		/* ¹Բǽ */
		if(p_tcb == my_p_runtsk) {
			/* Фȯ */
			if (!my_dspflg) {
				/* ǥѥåػʤ饨顼 */
				ercd = E_CTX;
			}
			else if (t_p_pcb == my_p_pcb) {
				/* Ʊץåꤷ */
				/* ͥٽ̤Ʊͥ٤ΥǺȤʤ */
				dspreq = rotate_ready_queue(p_tcb->priority, my_p_pcb);
				ercd = E_OK; 
			}
			else {
				/* ޥ졼׵ */
				LOG_TSKMIG(p_tcb, my_p_pcb->prcid, prcid);
				dispatch_and_migrate(prcid);
				/* äƤˤϥåϲƤ */
				ercd = E_OK;
				t_unlock_cpu();
				goto error_exit;
			}
		} 
		else {
			/* ¾ξ */
			if (t_p_pcb == my_p_pcb) {
				/* Ʊץå */
				/* ͥٽ̤Ʊͥ٤ΥǺȤʤ */
				rotate_ready_queue(p_tcb->priority, my_p_pcb);
				ercd = E_OK; 
			}
			else {
				/* ۤʤץå */
				/* ǥ塼鳰 */
				make_non_runnable(p_tcb);
				/* pcb ν񤭴 */
				p_tcb->p_pcb = t_p_pcb;
				LOG_TSKMIG(p_tcb, my_p_pcb->prcid, prcid);
				/* ܹΥץåmake_runnable */
				if (make_runnable(p_tcb)) {
					dispatch_request(p_tcb->p_pcb);
				}
				ercd = E_OK;
			}
		}
	}
	else if (TSTAT_DORMANT(p_tcb->tstat)) {
		/* ٻ߾ */
		LOG_TSKMIG(p_tcb, my_p_pcb->prcid, prcid);
		p_tcb->p_pcb = t_p_pcb;
		ercd = E_OK;
	}
	else {
		/* Ԥ */
		if ((p_tcb->tmevtb).callback == NULL) {
			/* ԤǤʤ */
			LOG_TSKMIG(p_tcb, my_p_pcb->prcid, prcid);
			p_tcb->p_pcb = t_p_pcb;
			ercd = E_OK;
		}
		else {
			/*
			 * Ԥξ Х륿 ʤɬפʤ
			 */
#ifdef TOPPERS_SYSTIM_LOCAL
			/* 塼 */
			event_time = tmevtb_dequeue(p_tcb->p_pcb->p_tevtcb, &(p_tcb->tmevtb));
			/*
			 * ưΥץå֤ʤǤСॢȻ
			 * Ĺ롥 
			 */
			if (base_time(p_tcb->p_pcb->p_tevtcb) < base_time(t_p_pcb->p_tevtcb)){
				event_time += base_time(t_p_pcb->p_tevtcb) - base_time(p_tcb->p_pcb->p_tevtcb);
			}
			LOG_TSKMIG(p_tcb, my_p_pcb->prcid, prcid);
			/* ưΥץåΥ塼 */
			tmevtb_insert(t_p_pcb->p_tevtcb, &(p_tcb->tmevtb), event_time);
#else  /* TOPPERS_SYSTIM_GLOBAL */
			LOG_TSKMIG(p_tcb, my_p_pcb->prcid, prcid);
#endif /* TOPPERS_SYSTIM_GLOBAL */
			p_tcb->p_pcb = t_p_pcb;
			ercd = E_OK;
		}
	}
	T_RELEASE_DUAL_TSK_LOCK_AND_DISPATCH(f_p_pcb, t_p_pcb, dspreq);

  error_exit:
	LOG_MIG_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_mig_tsk */

/*
 *  εư
 */
#ifdef TOPPERS_act_tsk

ER
act_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_ACT_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		if (make_active(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		ercd = E_OK;
	}
	else if (!(p_tcb->actque)) {
		p_tcb->actque = true;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);

  error_exit:
	LOG_ACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_act_tsk */

/*
 *  εư󥿥ƥѡ
 */
#ifdef TOPPERS_iact_tsk

ER
iact_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;

	LOG_IACT_TSK_ENTER(tskid);
	CHECK_INTCTX_UNL();
	CHECK_TSKID(tskid);
	p_tcb = get_tcb(tskid);

  retry:
	I_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		if (make_active(p_tcb)) {
			if (dispatch_request(p_tcb->p_pcb)) {
				my_reqflg = true;
			}
		}
		ercd = E_OK;
	}
	else if (!(p_tcb->actque)) {
		p_tcb->actque = true;
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	I_RELEASE_TSK_LOCK(p_tcb->p_pcb);

  error_exit:
	LOG_IACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_iact_tsk */

/*
 *  ץåΥεư
 */
#ifdef TOPPERS_mact_tsk

ER
mact_tsk(ID tskid, ID prcid)
{
	TCB		*p_tcb;
	ER		ercd;
	PCB		*t_p_pcb;
	PCB		*f_p_pcb;
	bool_t	dspreq = false;

	LOG_MACT_TSK_ENTER(tskid, prcid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	CHECK_PRCID_INI(prcid);
	p_tcb = get_tcb_self(tskid);
	prcid = (prcid == TPRC_INI)? p_tcb->p_tinib->iaffinity : prcid;
	CHECK_MIG(p_tcb->p_tinib->affinity_mask, prcid);
	/* ưΥץåPCB */
	t_p_pcb = mp_pcb(prcid);

  retry:
	/* ߳դƤץåȰưΥץåΥå */
	T_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, t_p_pcb);
	/* åΤ¸ */
	f_p_pcb = p_tcb->p_pcb;
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		LOG_TSKMIG(p_tcb, f_p_pcb->prcid, prcid);
		p_tcb->p_pcb = t_p_pcb;
		if (make_active(p_tcb)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
		ercd = E_OK;
	}
	else if (!(p_tcb->actque)) {
		p_tcb->actque = true;
		/* ưΥץåǳդƤץåȰۤʤ */
		if (t_p_pcb != p_tcb->p_pcb) {
			p_tcb->actprc = prcid;
		}
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	T_RELEASE_DUAL_TSK_LOCK_AND_DISPATCH(f_p_pcb, t_p_pcb, dspreq);

  error_exit:
	LOG_MACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_mact_tsk */

/*
 *  ץåΥεư󥿥ƥѡ
 */
#ifdef TOPPERS_imact_tsk

ER
imact_tsk(ID tskid, ID prcid)
{
	TCB		*p_tcb;
	ER		ercd;
	PCB		*t_p_pcb;
	PCB		*f_p_pcb;

	LOG_IMACT_TSK_ENTER(tskid, prcid);
	CHECK_INTCTX_UNL();
	CHECK_TSKID(tskid);
	CHECK_PRCID_INI(prcid);
	p_tcb = get_tcb(tskid);
	prcid = (prcid == TPRC_INI)? p_tcb->p_tinib->iaffinity : prcid;
	CHECK_MIG(p_tcb->p_tinib->affinity_mask, prcid);
	/* ưΥץåPCB */
	t_p_pcb = mp_pcb(prcid);

  retry:
	/* ߳դƤץåȰưΥץåΥå */
	I_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, t_p_pcb);
	/* åΤ¸ */
	f_p_pcb = p_tcb->p_pcb;
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		LOG_TSKMIG(p_tcb, f_p_pcb->prcid, prcid);
		p_tcb->p_pcb = t_p_pcb;
		if (make_active(p_tcb)) {
			if (dispatch_request(p_tcb->p_pcb)) {
				my_reqflg = true;
			}
		}
		ercd = E_OK;
	}
	else if (!(p_tcb->actque)) {
		p_tcb->actque = true;
		/* ưΥץå߳դƤץåȰۤʤ */
		if (t_p_pcb != p_tcb->p_pcb) {
			p_tcb->actprc = prcid;
		}
		ercd = E_OK;
	}
	else {
		ercd = E_QOVR;
	}
	I_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb);

  error_exit:
	LOG_IMACT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_imact_tsk */

/*
 *  ư׵Υ󥻥
 */
#ifdef TOPPERS_can_act

ER_UINT
can_act(ID tskid)
{
	TCB		*p_tcb;
	ER_UINT	ercd;

	LOG_CAN_ACT_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	ercd = p_tcb->actque ? 1 : 0;
	p_tcb->actque = false;
	p_tcb->actprc = 0U;
	T_RELEASE_TSK_LOCK(p_tcb->p_pcb);

  error_exit:
	LOG_CAN_ACT_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_can_act */

/*
 *  νλ
 */
#ifdef TOPPERS_ext_tsk

#if TTYPE_KLOCK == G_KLOCK

ER
ext_tsk(void)
{
	ER		ercd;

	LOG_EXT_TSK_ENTER();
	CHECK_TSKCTX();

  retry:
	if (t_sense_lock()) {
		/*
		 *  CPUå֤ext_tskƤФ줿ϡCPUå
		 *  Ƥ饿λ롥ϡӥǤCPU
		 *  åάФ褤
		 */
	}
	else {
		t_lock_cpu();
	}

	T_ACQUIRE_TSK_LOCK_AND_CHECK_RUNNABLE();

	if (my_disdsp) {
		/*
		 *  ǥѥåػ߾֤ext_tskƤФ줿ϡǥѥ
		 *  ľ֤ˤƤ饿λ롥
		 */
		my_disdsp = false;
	}
	if (t_get_ipm() != TIPM_ENAALL) {
		/*
		 *  ͥ٥ޥIPMˤTIPM_ENAALLʳξ֤ext_tsk
		 *  ƤФ줿ϡIPMTIPM_ENAALLˤƤ饿λ
		 *  롥
		 */
		t_set_ipm(TIPM_ENAALL);
	}
	my_dspflg = true;
	/*
	 *  ԥåƤϡԥå
	 */
	force_unlock_spin();

	/* ƵưΥޥ졼ʤ */
	if (my_p_runtsk->actprc == 0U) {
		(void) make_non_runnable(my_p_runtsk);
		make_dormant(my_p_runtsk);
		if (my_p_runtsk->actque) {
			my_p_runtsk->actque = false;
			(void) make_active(my_p_runtsk);
		}
		RELEASE_TSK_LOCK(my_p_pcb);
		exit_and_dispatch();
		assert(0);
	}
	else {
		/* ߥƥȤΤƤƥޥ졼 */
		exit_and_migrate(my_p_runtsk->actprc);
		assert(0);
	}

  error_exit:
	LOG_EXT_TSK_LEAVE(ercd);
	return(ercd);
}

#else /* TTYPE_KLOCK != G_KLOCK */


ER
ext_tsk(void)
{
	ER		ercd;
	PCB		*t_p_pcb;

	LOG_EXT_TSK_ENTER();
	CHECK_TSKCTX();

  retry:
	if (t_sense_lock()) {
		/*
		 *  CPUå֤ext_tskƤФ줿ϡCPUå
		 *  Ƥ饿λ롥ϡӥǤCPU
		 *  åάФ褤
		 */
	}
	else {
		t_lock_cpu();
	}

	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(my_p_runtsk->p_pcb);

	if (my_disdsp) {
		/*
		 *  ǥѥåػ߾֤ext_tskƤФ줿ϡǥѥ
		 *  ľ֤ˤƤ饿λ롥
		 */
		my_disdsp = false;
	}
	if (t_get_ipm() != TIPM_ENAALL) {
		/*
		 *  ͥ٥ޥIPMˤTIPM_ENAALLʳξ֤ext_tsk
		 *  ƤФ줿ϡIPMTIPM_ENAALLˤƤ饿λ
		 *  롥
		 */
		t_set_ipm(TIPM_ENAALL);
	}
	my_dspflg = true;
	/*
	 *  ԥåƤϡԥå
	 */
	force_unlock_spin();

	/* ƵưΥޥ졼ʤ */
	if (my_p_runtsk->actprc == 0U) {
		(void) make_non_runnable(my_p_runtsk);
		make_dormant(my_p_runtsk);
		if (my_p_runtsk->actque) {
			my_p_runtsk->actque = false;
			(void) make_active(my_p_runtsk);
		}
		RELEASE_TSK_LOCK(my_p_pcb);
		exit_and_dispatch();
		assert(0);
	}
	else {
		/* ưΥץåPCB */
		t_p_pcb = mp_pcb(my_p_runtsk->actprc);
		/* öåΥ */
		T_RELEASE_TSK_LOCK(my_p_runtsk->p_pcb);

		/*
		 * ߳դƤץåȰưΥץåΥ
		 * å
		 */
		T_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(my_p_runtsk->p_pcb, t_p_pcb);
		/*
		 * ޥ졼Υץåѹ줿ϥȥ饤
		 */
		if (mp_pcb(my_p_runtsk->actprc) != t_p_pcb) {
			T_RELEASE_DUAL_TSK_LOCK(my_p_runtsk->p_pcb, t_p_pcb);
			goto retry;
		}
		/* ߥƥȤΤƤƥޥ졼 */
		exit_and_migrate(my_p_runtsk->actprc);
		assert(0);
	}

  error_exit:
	LOG_EXT_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TTYPE_KLOCK != G_KLOCK */

#endif /* TOPPERS_ext_tsk */

/*
 *  ζλ
 */
#ifdef TOPPERS_ter_tsk

#if TTYPE_KLOCK == G_KLOCK
ER
ter_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_TER_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID(tskid);
	p_tcb = get_tcb(tskid);
	CHECK_NONSELF(p_tcb);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	/* ۤʤץå˳դƤ륿ʤ饨顼Ȥ */
	if (p_tcb->p_pcb != my_p_pcb) {
		ercd = E_OBJ;
	}
	else if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		if (TSTAT_RUNNABLE(p_tcb->tstat)) {
			/*
			 * оݥ¾ץåΥRUNNABLEξ硤
			 * RUN֤βǽ뤿ᡤǥѥå׵Фɬפ뤬
			 * ܥƥॳƱץå˳դƤ륿Τ
			 * ȯԲǽǤΤǡǥѥå׵ФɬפϤʤ 
			 */
			(void)make_non_runnable(p_tcb);
		}
		else if (TSTAT_WAITING(p_tcb->tstat)) {
			wait_dequeue_wobj(p_tcb);
			wait_dequeue_tmevtb(p_tcb);
		}
		make_dormant(p_tcb);
		if (p_tcb->actque) {
			p_tcb->actque = false;
			/*
			 * ޥ졼׵᤬塼󥰤Ƥϡ
			 * ޥ졼Ԥ 
			 */
			if (p_tcb->actprc != 0U) {
				p_tcb->p_pcb = mp_pcb(p_tcb->actprc);
				p_tcb->actprc = 0U;
			}
			if (make_active(p_tcb)) {
				if(dispatch_request(p_tcb->p_pcb)){
					dispatch();
				}
			}
		}
		ercd = E_OK;
	}
	T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);

  error_exit:
	LOG_TER_TSK_LEAVE(ercd);
	return(ercd);
}

#else /* TTYPE_KLOCK != G_KLOCK */

ER
ter_tsk(ID tskid)
{
	TCB		*p_tcb;
	ER		ercd = E_OK;
	bool_t	dspreq = false;
	PCB		*f_p_pcb;
	PCB		*t_p_pcb;

	LOG_TER_TSK_ENTER(tskid);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID(tskid);
	p_tcb = get_tcb(tskid);
	CHECK_NONSELF(p_tcb);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	/* ۤʤץå˳դƤ륿ʤ饨顼Ȥ */
	if (p_tcb->p_pcb != my_p_pcb) {
		ercd = E_OBJ;
		T_RELEASE_TSK_LOCK(p_tcb->p_pcb);
	}
	else if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
		T_RELEASE_TSK_LOCK(p_tcb->p_pcb);
	}
	else {
		if (!(TSTAT_WAITING(p_tcb->tstat) && TSTAT_WAIT_WOBJ(p_tcb->tstat))) {
			/* ֥Ԥʳξ֤ξ */
			if (p_tcb->actprc == 0U) {
				/* ƵưΥޥ졼ʤ */
				if (TSTAT_RUNNABLE(p_tcb->tstat)) {
					/*
					 * оݥ¾ץåΥRUNNABLEξ硤
					 * RUN֤βǽ뤿ᡤǥѥå׵Фɬפ뤬
					 * ܥƥॳƱץå˳դƤ륿Τ
					 * ȯԲǽǤΤǡǥѥå׵ФɬפϤʤ 
					 */
					(void)make_non_runnable(p_tcb);
				}
				else {
					/* ֥ԤʳԤ */
					wait_dequeue_tmevtb(p_tcb);
				}
				make_dormant(p_tcb);
				if (p_tcb->actque) {
					p_tcb->actque = false;
					if (make_active(p_tcb)) {
						dspreq = dispatch_request(p_tcb->p_pcb);
					}
				}
				T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);
			}
			else {
				/* ư׵ᥭ塼󥰤 & ޥ졼󤢤 */
				/* ưΥץåPCB */
				t_p_pcb = mp_pcb(p_tcb->actprc);
				/* öåΥ */
				T_RELEASE_TSK_LOCK(p_tcb->p_pcb);

				/*
				 * ߳դƤץåȰưΥץåΥ
				 * å
				 */
				T_ACQUIRE_DUAL_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, t_p_pcb);

				/*
				 *  ޥ졼Υץåѹ줿ϥȥ饤
				 *  оݥ伫¾Υץåإޥ졼󤵤줿
				 *  ϥ顼Ȥ롥 
				 */
				if ((mp_pcb(p_tcb->actprc) != t_p_pcb) || (p_tcb->p_pcb != my_p_pcb)) {
					T_RELEASE_DUAL_TSK_LOCK(p_tcb->p_pcb, t_p_pcb);
					goto retry;
				}
				if (TSTAT_RUNNABLE(p_tcb->tstat)) {
					/*
					 * оݥ¾ץåΥRUNNABLEξ硤
					 * RUN֤βǽ뤿ᡤǥѥå׵Фɬפ뤬
					 * ܥƥॳƱץå˳դƤ륿Τ
					 * ȯԲǽǤΤǡǥѥå׵ФɬפϤʤ 
					 */
					(void)make_non_runnable(p_tcb);
				}
				else if (TSTAT_WAITING(p_tcb->tstat) && !TSTAT_WAIT_WOBJ(p_tcb->tstat)) {
					/* ֥ԤʳԤ */
					wait_dequeue_tmevtb(p_tcb);
				}
				else {
					/* 嵭ʳʤ饿ξ֤ѤäƤ뤿ȥ饤 */
					T_RELEASE_DUAL_TSK_LOCK(p_tcb->p_pcb, t_p_pcb);
					goto retry;
				}
				make_dormant(p_tcb);
				p_tcb->actque = false;
				p_tcb->actprc = 0U;
				f_p_pcb = p_tcb->p_pcb;
				p_tcb->p_pcb = t_p_pcb;
				if (make_active(p_tcb)) {
					/*
					 *  оݥϼƱץå˳դ
					 *  Ƥ륿Ǥ뤿ᡤǥѥå
					 *  ȤϤʤ 
					 */
					(void)dispatch_request(p_tcb->p_pcb);
				}
				T_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb);
			}
		}
		else {
			/* ֥Ԥ֤ξ */
			if (p_tcb->actprc == 0U) {
				/* ƵưΥޥ졼ʤ */
				/*
				 * ǥåɥåΤᡤåľ 
				 */
				WOBJCB *p_wobjcb = p_tcb->p_wobjcb;
				RELEASE_TSK_LOCK(p_tcb->p_pcb);
				/*
				 * 餿
				 *   ֥ȥå -> å
				 * νǥå 
				 */
				if (ACQUIRE_OBJ_LOCK(p_wobjcb)) {
					t_unlock_cpu();
					goto retry;
				}
				T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_wobjcb);
				/*
				 * ۤʤ륪֥ȤФԤˤʤäƤʤå
				 */
				if (p_wobjcb != p_tcb->p_wobjcb) {
					/*
					 *  ۤʤ륪֥ȤФԤˤʤäƤХȥ饤
					 */
					T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
					T_RELEASE_OBJ_LOCK(p_wobjcb);
					goto retry;
				}
				wait_dequeue_wobj(p_tcb);
				wait_dequeue_tmevtb(p_tcb);
				RELEASE_OBJ_LOCK(p_wobjcb);
				make_dormant(p_tcb);
				if (p_tcb->actque) {
					p_tcb->actque = false;
					if (make_active(p_tcb)) {
						dspreq = dispatch_request(p_tcb->p_pcb);
					}
				}
				T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);
			}
			else {
				/* ư׵ᥭ塼󥰤 & ޥ졼 */
				/* ưΥץåPCB */
				t_p_pcb = mp_pcb(p_tcb->actprc);
				/*
				 * ǥåɥåΤᡤåľ 
				 */
				WOBJCB *p_wobjcb = p_tcb->p_wobjcb;
				RELEASE_TSK_LOCK(p_tcb->p_pcb);

				/*
				 * 餿
				 *   ֥ȥå -> å
				 * νǥå 
				 */
				if (ACQUIRE_OBJ_LOCK(p_wobjcb)) {
					t_unlock_cpu();
					goto retry;
				}
				T_ACQUIRE_NESTED_DUAL_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, t_p_pcb, p_wobjcb);
				/*
				 * ۤʤ륪֥ȤФԤۤʤץåؤΥ
				 * 졼оݥޥ졼ȤƤʤ
				 * ȥ饤
				 */
				if ((p_wobjcb != p_tcb->p_wobjcb) |
					     (mp_pcb(p_tcb->actprc) != t_p_pcb) || (p_tcb->p_pcb != my_p_pcb)) {
					RELEASE_DUAL_TSK_LOCK(p_tcb->p_pcb, t_p_pcb);
					T_RELEASE_OBJ_LOCK(p_wobjcb);
					goto retry;
				}
				wait_dequeue_wobj(p_tcb);
				wait_dequeue_tmevtb(p_tcb);
				RELEASE_OBJ_LOCK(p_wobjcb);

				make_dormant(p_tcb);
				p_tcb->actque = false;
				p_tcb->actprc = 0U;
				f_p_pcb = p_tcb->p_pcb;
				p_tcb->p_pcb = t_p_pcb;
				if (make_active(p_tcb)) {
					/*
					 *  оݥϼƱץå˳դ
					 *  Ƥ륿Ǥ뤿ᡤǥѥå
					 *  ȤϤʤ 
					 */
					(void)dispatch_request(p_tcb->p_pcb);
				}
				T_RELEASE_DUAL_TSK_LOCK(f_p_pcb, t_p_pcb);
			}
		}
	}

  error_exit:
	LOG_TER_TSK_LEAVE(ercd);
	return(ercd);
}

#endif /* TTYPE_KLOCK != G_KLOCK */

#endif /* TOPPERS_ter_tsk */

/*
 *  ͥ٤ѹ
 */
#ifdef TOPPERS_chg_pri

ER
chg_pri(ID tskid, PRI tskpri)
{
	TCB		*p_tcb;
	uint_t	newpri;
	ER		ercd;
	bool_t	dspreq = false;

	LOG_CHG_PRI_ENTER(tskid, tskpri);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	CHECK_TPRI_INI(tskpri);
	p_tcb = get_tcb_self(tskid);
	newpri = (tskpri == TPRI_INI) ? p_tcb->p_tinib->ipriority
										: INT_PRIORITY(tskpri);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
#if TTYPE_KLOCK == G_KLOCK
		if (change_priority(p_tcb, newpri)) {
			dspreq = dispatch_request(p_tcb->p_pcb);
		}
#else /* TTYPE_KLOCK != G_KLOCK */
		if (TSTAT_RUNNABLE(p_tcb->tstat)) {
			if (change_priority(p_tcb, newpri)) {
				dspreq = dispatch_request(p_tcb->p_pcb);
			}
		}
		else if (!TSTAT_WAIT_WOBJ(p_tcb->tstat)) {
			/* ֥ԤǤʤ */
			p_tcb->priority = newpri;
		}
		else {
			/*
			 * ֥Ԥξ
			 * ǥåɥåΤᡤåľ 
			 */
			WOBJCB *p_wobjcb = p_tcb->p_wobjcb;
			p_tcb->pend_chgpri = true;
			p_tcb->pend_newpri = newpri;
			RELEASE_TSK_LOCK(p_tcb->p_pcb);

			/*
			 * 餿
			 *   ֥ȥå -> å
			 * νǥå 
			 */
			if (ACQUIRE_OBJ_LOCK(p_wobjcb)) {
				t_unlock_cpu();
				goto retry;
			}
			T_ACQUIRE_NESTED_LOCK_AND_CHECK_MIG(p_tcb->p_pcb, p_wobjcb);

			/* ξ֤ѲƤʤå */
			if (!(p_tcb->pend_chgpri)) {
				/* ¾βսԤʤ줿 */
				T_RELEASE_NESTED_LOCK(p_tcb->p_pcb);
				T_RELEASE_OBJ_LOCK(p_wobjcb);
				ercd = E_OK;
				goto error_exit;
			}

			p_tcb->priority = p_tcb->pend_newpri;
			p_tcb->pend_chgpri = false;
			change_priority(p_tcb, newpri);
			RELEASE_OBJ_LOCK(p_wobjcb);
		}
#endif /* TTYPE_KLOCK != G_KLOCK */
		ercd = E_OK;
	}
	T_RELEASE_TSK_LOCK_AND_DISPATCH(p_tcb->p_pcb, dspreq);

  error_exit:
	LOG_CHG_PRI_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_chg_pri */

/*
 *  ͥ٤λ
 */
#ifdef TOPPERS_get_pri

ER
get_pri(ID tskid, PRI *p_tskpri)
{
	TCB		*p_tcb;
	ER		ercd;

	LOG_GET_PRI_ENTER(tskid, p_tskpri);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);

  retry:
	T_ACQUIRE_TSK_LOCK_AND_CHECK_MIG(p_tcb->p_pcb);
	if (TSTAT_DORMANT(p_tcb->tstat)) {
		ercd = E_OBJ;
	}
	else {
		*p_tskpri = EXT_TSKPRI(p_tcb->priority);
		ercd = E_OK;
	}
	T_RELEASE_TSK_LOCK(p_tcb->p_pcb);

  error_exit:
	LOG_GET_PRI_LEAVE(ercd, *p_tskpri);
	return(ercd);
}

#endif /* TOPPERS_get_pri */

/*
 *  γĥλ
 */
#ifdef TOPPERS_get_inf

ER
get_inf(intptr_t *p_exinf)
{
	ER		ercd;

	LOG_GET_INF_ENTER(p_exinf);
	CHECK_TSKCTX_UNL();

  retry:
	T_ACQUIRE_TSK_LOCK(my_p_pcb);
	*p_exinf = my_p_runtsk->p_tinib->exinf;
	ercd = E_OK;
	T_RELEASE_TSK_LOCK(my_p_pcb);

  error_exit:
	LOG_GET_INF_LEAVE(ercd, *p_exinf);
	return(ercd);
}

#endif /* TOPPERS_get_inf */
