/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: naviengine.c 249 2009-04-30 07:02:21Z ertl-honda $
 */

#include "kernel_impl.h"
#include "naviengine.h"

#ifdef G_SYSLOG

#define my_prc_uart_base	UART0_BASE

#else

/*
 *  ٥Ϥǥץå˻ѤUARTΥɥ쥹
 */
const uint32_t prc_uart_base_tbl[TNUM_PRC] = {
	UART0_BASE,
#if TNUM_PRC >= 2
	UART1_BASE,
#endif /* TNUM_PRC >= 2 */
#if TNUM_PRC >= 3
	UART2_BASE,  
#endif /* TNUM_PRC >= 3 */
#if TNUM_PRC >= 4
	UART3_BASE,
#endif /* TNUM_PRC >= 4 */
};

/*
 *  ץåѤUARTΥɥ쥹
 */
#define my_prc_uart_base	(prc_uart_base_tbl[x_prc_index()])

#endif /* G_SYSLOG */


/*
 *  UARTΥݡ󥰽
 */
void
naviengine_uart_putc(char_t c)
{
	/* ХåեΤԤ */
	while((sil_reb_mem((void *)(my_prc_uart_base + UART_LSR_REG)) & 0x20U)
          == 0x00U);
	/* 񤭹 */
	sil_wrb_mem((void *)(my_prc_uart_base + UART_THR_REG), c);
	/* ХåեΤԤ */
	while((sil_reb_mem((void *)(my_prc_uart_base + UART_LSR_REG)) & 0x20U)
		  == 0x00U);
}


/*
 * ݡ󥰽ϤΤν
 */
void
naviengine_uart_init(void)
{
	sil_wrb_mem((void *)(my_prc_uart_base + UART_LCR_REG), 0x83);
	sil_wrb_mem((void *)(my_prc_uart_base + UART_DLL_REG), 0xD8);
	sil_wrb_mem((void *)(my_prc_uart_base + UART_DLM_REG), 0x00);
	sil_wrb_mem((void *)(my_prc_uart_base + UART_LCR_REG), 0x03);
	sil_wrb_mem((void *)(my_prc_uart_base + UART_IER_REG), 0x00);
	sil_wrb_mem((void *)(my_prc_uart_base + UART_FCR_REG), 0x00);
}
