/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel    
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: ns16550.h 91 2009-01-25 16:50:43Z ertl-honda $
 */

/*
 *   NS16550  ʰSIOɥ饤
 */
#ifndef TOPPERS_NS16550_H
#define TOPPERS_NS16550_H

/*
 *  ꥢI/Oݡȿ
 */
#define TNUM_SIOP		4		/* ݡȤ륷ꥢI/OݡȤο */

#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND	1U		/* ǽХå */
#define SIO_RDY_RCV	2U		/* ΥХå */

/*
 * ͥ뵯ưѤν(sys_putcѤ뤿)
 */
extern void ns16550_init(void);

/*
 *  ꥢI/OݡȤؤΥݡ󥰤Ǥν
 */
extern void ns16550_pol_putc(char_t c, ID siopid);

/*
 *  SIOɥ饤Фν롼
 */
extern void ns16550_initialize(void);

/*
 *  ץ󤷤ƤݡȤ뤫
 */
extern bool_t ns16550_openflag(ID siopid);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB  *ns16550_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void ns16550_cls_por(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t ns16550_snd_chr(SIOPCB *siopcb, char_t c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t ns16550_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void ns16550_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void ns16550_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  SIOγߥӥ롼
 */
extern void ns16550_isr(intptr_t exinf);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void ns16550_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void ns16550_irdy_rcv(intptr_t exinf);

/*
 *  SIOPCBؤΥݥ󥿤ݡֹ֤
 */
extern ID ns16550_get_siopid(SIOPCB *p_siopcb);

/*
 *  ֹ֤
 */
extern uint8_t ns16550_get_intno(SIOPCB *p_siopcb);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_NS16550_H */
