/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007,2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mig_tsk1.c 175 2009-03-03 13:19:45Z ertl-kikuchi $
 */

/* 
 *		mig_tskӥΥƥ(1)
 *  ڥƥȤŪ
 *    оݥٻ߾֡¹Բǽ֤ΥФơmig_tskȯԤ롥
 *
 *  ڥƥȹܡ
 *    (1-A)оݥٻ߾
 *    ¹Բǽ֤ΥϤˡưCPUΥǥ塼Ǥΰ֤ˤʬԤ
 *
 *    (1-B) ǹͥ
 *    (1-C) ¹Ծ֤ΥƱͥ
 *    (1-D) ¹Ծ֤Υͥ
 *    (1-E) ǥ塼ΤȤذư
 */

#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "test_lib.h"

void
task1_1(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	check_point(1);
	ercd = mig_tsk(TASK1_5,2);
	check_ercd(ercd, E_OK);

	check_point(2);
	ercd = mig_tsk(TASK1_3,2);
	check_ercd(ercd, E_OK);

	//1-3runԤ
	do{
		ercd = pol_flg(FLG1,8,TWF_ANDW,&flgptn);
	} while(ercd != E_OK);

	check_point(3);
	ercd = mig_tsk(TASK1_4,2);
	check_ercd(ercd, E_OK);
  
	check_point(4);
	ercd = mig_tsk(TASK1_7,2);
	check_ercd(ercd, E_OK);

	//Ʊե饰å 1_3˰ưλ
	check_point(5);
	ercd = set_flg(FLG1,1);
	check_ercd(ercd, E_OK);

	//Ʊե饰åԤ 1_7εưԤ
	do{
		ercd = pol_flg(FLG1,2,TWF_ANDW,&flgptn);
	} while(ercd != E_OK);

	check_point(6);
	ercd = mig_tsk(TASK1_6,2);
	check_ercd(ercd, E_OK);

	check_point(7);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task1_3(intptr_t exinf)
{
	ER		ercd;
	FLGPTN flgptn;

	check_point(1);

	//1-1˰ư
	ercd = set_flg(FLG1,8);
	check_ercd(ercd, E_OK);

	do{
		ercd = pol_flg(FLG1,1,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);
  
	check_point(2);
	ercd = act_tsk(TASK1_5);
	check_ercd(ercd, E_OK);

	check_point(3);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task1_4(intptr_t exinf)
{
	ER		ercd;

	check_point(4);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task1_5(intptr_t exinf)
{
	ER		ercd;

	check_point(5);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task1_6(intptr_t exinf)
{
	ER		ercd;

	check_point(7);
	ercd = set_flg(FLG1,4);
	check_ercd(ercd, E_OK);

	check_point(8);
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	check_point(0);
}

void
task1_7(intptr_t exinf)
{
	ER		ercd;
	FLGPTN  flgptn;

	check_point(6);
	//Ʊե饰å 1_1˵ư
	ercd = set_flg(FLG1,2);
	check_ercd(ercd, E_OK);

	//Ʊե饰åԤ 1_6εưԤ
	do{
		ercd = pol_flg(FLG1,4,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);
  
	check_point(9);
	//Ʊե饰å
	ercd = set_flg(FLG1,0x10);
	check_ercd(ercd, E_OK);

	check_point(10);
	//Ʊե饰å
	ercd = slp_tsk();
	check_ercd(ercd, E_OK);
    
	check_point(0);
}

void
task1_8(intptr_t exinf)
{
	ER		ercd;
	FLGPTN flgptn;
  
	check_point(8);
  
	do{
		ercd = pol_flg(FLG1,0x10,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(9);
	ercd = mig_tsk(TASK1_9,2);
	check_ercd(ercd, E_OK);

	/*
	 *  ƥȽλ
	 */

	check_finish(10);//CPU1

}

void
task1_9(intptr_t exinf)
{
	/*
	 *  ƥȽλ
	 */
    check_finish(11);//CPU2
}
